"Array" <-
function (structure) 
{
    par(oma = c(2, 0, 2, 0))
    Names = names(structure)
    dataVectorType = unlist(lapply(structure, attr, "DataVectorType"))
    axisLength = length(dataVectorType[dataVectorType != "Value"])
    dataType = unlist(lapply(structure, attr, "dataType"))
    dataType = dataType[1:axisLength]
    num = seq(dataType)[dataType == "Id" | dataType == "Number"]
    if (length(num) != 0) {
        axisLength = axisLength - length(num)
    }
    MF = 1
    if (axisLength > 2) {
        par(mfrow = c(2, 2))
        MF = 4
    }
    else {
        if (axisLength > 1) {
            par(mfrow = c(1, 2))
            MF = 2
        }
    }
    Pin = par("pin")[1]
    Cin = par("cin")[1]
    for (l in seq(dataVectorType)[dataVectorType == "Value"]) {
        valueVector = structure[[l]]
        for (m in 1:axisLength) {
            if (match(m, num, 0) == 0) {
                x = split(get(Names[l]), get(Names[m]))
                xmax = max(nchar(names(x)))
                Plen = (Pin%/%Cin * 0.9)%/%xmax
                xline = ceiling(length(x)/Plen)
                if (xline >= 4) 
                  par(mar = c(xline + 2, 4, 2, 2))
                else par(mar = c(5, 4, 2, 2))
                mline = par("mar")[1]
                At = bxp(boxplot(x, plot = F, names = rep("", 
                  length(x))))
                mtext("Array", outer = T, side = 3, col = 4, 
                  cex = 2)
                mtext(attr(valueVector, "LongName"), side = 2, 
                  col = 4, line = 3)
                ytype = attr(valueVector, "DataType")
                if (!is.null(ytype)) 
                  mtext(paste("(", attr(valueVector, "Unit"), 
                    ", ", ytype, ")"), side = 2, col = 2, line = 2)
                else mtext(paste("(", attr(valueVector, "Unit"), 
                  ")"), side = 2, col = 2, line = 2)
                Line = rep(seq(xline), Plen)[seq(length(x))]
                mtext(attr(structure[[m]], "LongName"), side = 1, 
                  line = mline - 1, col = 4)
                mtext(attr(structure[[m]], "DataType"), side = 1, 
                  line = mline, col = 3)
                if (attr(structure[[m]], "DataType") == "OrderedCategory") {
                  Xlab = c(names(x)[1], paste("> ", names(x)[-1]))
                  mtext(Xlab, side = 1, line = Line, at = At)
                }
                else mtext(names(x), side = 1, line = Line, at = At)
                browser()
            }
        }
        browser()
    }
    return()
}
