"DandD" <-
function (name = NULL, prefix = "http://www.stat.math.keio.ac.jp/DandDIV/Examples/", 
    radix = F, Language) 
{
    if(missing(Language)){
			Language = DandDoptions()$Language
		}
    instanceNames = c("Iris.dad", "NewSwimMen200Fr.dad", "Housing.dad", "2003Compe.dad", 
        "AcidRain.dad", 
        "Futures2002-2003.dad", "Marketing.dad", "BreathHeart.dad", "Gas_estima.dad", 
        "TOPIX1991-2002.dad", "Kyphosis.dad", "ProtoAyu.dad", "Solder.dad")
    if (is.null(name)) {
        x = menu(c(instanceNames), title = "Select Instance")
        name = instanceNames[x]
    }
    where = paste(prefix, name, sep = "")
    root = list(Title = NULL, Data = NULL, BackGround = NULL)
    if (length(grep("http", where))) {
        value = getString(paste("doc=loadDocument(\"", where, 
            "\")", sep = ""))
    }
    else {
        value = getStringLocal(paste("doc=loadDocument()", sep = ""), 
            where)
    }
    if (value != "") {
        stop(value)
    }
    getString("titleList=doc.getElementsByTagName(\"Title\")")
    titleString = getString("titleList.item(0).getAttribute(\"Title\")")
    languageString = getString("titleList.item(0).getAttribute(\"Language\")")
    if (!is.null(languageString)) {
        lang = unlist(strsplit(languageString, " "))
    }
    mlang = match(Language, lang, 1)
    langLength = length(lang)
    langNum = mlang
    
    getString("introList=doc.getElementsByTagName(\"Introduction\")")
    introString = getString("introList.item(0).getAttribute(\"Introduction\")")
    if (!is.null(introString)) {
        introId = unlist(strsplit(introString, " "))[langNum]
    }
    Intro = call("getIntroduction", introId, where) #getString(paste("getValue(doc.getElementById(\"", introId, "\"))", sep = ""))
    
    getString("dataVectorList=doc.getElementsByTagName(\"DataVector\")")
    dataVectorNum = as.numeric(getString("dataVectorList.getLength()"))
    if (!is.null(titleString)) {
        titleId = unlist(strsplit(titleString, " "))[langNum]
    }
    Title = getString(paste("getValue(doc.getElementById(\"", titleId, "\"))", sep = ""))
    getString("dlist=doc.getElementsByTagName(\"Data\")")
    getString("dclist=dlist.item(0).getChildNodes()")
    dcnum = (as.numeric(getString("dclist.getLength()")) - 1)
    num = 0
    structureId = NULL
    structureLongName = NULL
    getString("dataStructureList=doc.getElementsByTagName(\"Relation\")")
    dataStructureNum = as.numeric(getString("dataStructureList.getLength()"))
    structureAttr = getDataStructureAttributes(dataStructureNum, 
        langNum, langLength)
    #print(structureAttr)
    result = structure(as.list(seq(dataStructureNum)), .Names = structureAttr$ShortName)
    result = lapply(result, function(x) {
        structureAttributes = lapply(structureAttr, function(y) {
            if (y[x] != "") {
                y[x]
            }
        })
        structureAttributes[-c(1, 2)] = lapply(structureAttributes[-c(1, 
            2)], function(x) {
            if (!is.null(x)) {
                unlist(strsplit(x, " "))
            }
        })
        attributes(x) = structureAttributes
        x
    })
    result = lapply(result, function(x) {
        attr(x, "StructureType") = "Relation"
        x
    })
    temp = result
    for (i in 0:(dataStructureNum - 1)) {
        columns = attributes(result[[i + 1]])$Columns
        valueNum = length(columns)
        dataVectorAttr = getAttributesByIds(columns, langNum, 
            langLength)
        #print(dataVectorAttr)
        result[[i + 1]] = structure(as.list(seq(valueNum)), .Names = dataVectorAttr$ShortName)
        result[[i + 1]] = lapply(result[[i + 1]], function(x) {
            attr(x, "LongName") = dataVectorAttr[["LongName"]][x]
            x
        })
        result[[i + 1]] = lapply(result[[i + 1]], function(x) {
            if (as.character(dataVectorAttr[["RefId"]][x]) == 
                "") {
                attr(x, "Id") = unlist(strsplit(dataVectorAttr[["Id"]][x], 
                  " "))
            }
            else {
                attr(x, "Id") = unlist(strsplit(dataVectorAttr[["RefId"]][x], 
                  " "))
            }
            x
        })
        result[[i + 1]] = lapply(result[[i + 1]], function(x) {
            attr(x, "Numeral") = dataVectorAttr[["Numeral"]][x]
            if (attr(x, "Numeral") == "") {
                attr(x, "Numeral") = NULL
            }
            x
        })
        result[[i + 1]] = lapply(result[[i + 1]], function(x) {
            attr(x, "Unit") = dataVectorAttr[["Unit"]][x]
            if (attr(x, "Unit") == "") {
                attr(x, "Unit") = NULL
            }
            x
        })
        result[[i + 1]] = lapply(result[[i + 1]], function(x) {
            attr(x, "Numeral") = dataVectorAttr[["Numeral"]][x]
            if (attr(x, "Numeral") == "") {
                attr(x, "Numeral") = NULL
            }
            x
        })
        result[[i + 1]] = lapply(result[[i + 1]], function(x) {
            attr(x, "DataType") = dataVectorAttr[["DataType"]][x]
            if (attr(x, "DataType") == "") {
                attr(x, "DataType") = NULL
            }
            x
        })
        result[[i + 1]] = lapply(result[[i + 1]], function(x) {
            y = attributes(x)
            x = call("getDataVector", attr(x, "Id"), where, attr(x, 
                "DataType"), langNum)
            attributes(x) = y
            x
        })
        attributes(result[[i + 1]]) = c(attributes(result[[i + 
            1]]), attributes(temp[[i + 1]]))
        if (!is.null(attributes(temp[[i + 1]])$PrimaryKey)) {
            pkey = unlist(strsplit(attributes(temp[[i + 1]])$PrimaryKey, 
                " "))
            attr(result[[i + 1]], "PrimaryKey") = dataVectorAttr$ShortName[match(pkey, 
                dataVectorAttr$Id)]
        }
    }
    attr(result, "name") = name
    attr(result, "Title") = Title
    attr(result, "Language") = Language
    attr(result, "Introduction") = Intro
    #attr(result, "BackGround") = root$BackGround
    attr(result, "where") = where
    if (radix == T) {
        result = combineRadix(result)
    }
    class(result) = "dad"
    result = attachDandD(result)
    return(result)
}

