"PProcess" <-
function (structure) 
{
    Environment = attr(attr(structure, "Environment"), "name")
    Environment = match(Environment, search())
    Names = names(structure)
    dataVectorType = unlist(lapply(structure, attr, "DataVectorType"))
    condVectorNumber = NULL
    if (sum(dataVectorType == "Condition")) {
        condVectorNumber = seq(dataVectorType)[dataVectorType == 
            "Condition"]
        conditionVector = structure[condVectorNumber]
        Sfactor = NULL
        for (i in 1:length(condVectorNumber)) Sfactor = c(paste(Sfactor, 
            get(Names[condVectorNumber[i]], Environment), sep = ","))
        Slen = length(unique(Sfactor))
    }
    timePointNumber = seq(dataVectorType)[dataVectorType == "TimePoint"]
    pointVectorNumber = seq(dataVectorType)[dataVectorType == 
        "Point"]
    markVectorNumber = seq(dataVectorType)[dataVectorType == 
        "Mark"]
    if (length(timePointNumber)) {
        Tvector = structure[timePointNumber]
        Pvector = NULL
        if (length(pointVectorNumber)) {
            Pvector = structure[pointVectorNumber]
        }
        if (length(pointVectorNumber)) {
            if (length(markVectorNumber)) {
                for (k in 1:length(markVectorNumber)) {
                  Mvector = structure[markVectorNumber[k]]
                  if (length(Pvector) == 2) {
                    if (match("package:scatterplot3d", search(), 
                      0) == 0) {
                      library(scatterplot3d)
                    }
                    x = get(names(Pvector[1]), Environment)
                    z = get(names(Pvector[2]), Environment)
                    y = get(names(Tvector), Environment)
                    Colnum = Split(as.numeric(get(names(Mvector), 
                      Environment)))
                    scatterplot3d(x, y, z, , xlab = "", ylab = "", 
                      zlab = "", pch = 16, mar = c(7, 3, 5, 3), 
                      color = Colnum[[1]])
                    mtext("PointProcess", outer = T, side = 3, 
                      cex = 2, col = 4)
                    mtext(attr(Mvector[[1]], "LongName"), side = 3, 
                      col = 3, cex = 1.5)
                    mtext("Longitude", side = 1, col = 4, line = 2)
                    mtext(paste("(", attr(Pvector[[1]], "Unit"), 
                      ")"), side = 1, col = 2, line = 3)
                    mtext("Latitude", side = 2, col = 4, line = 3)
                    mtext(paste("(", attr(Pvector[[2]], "Unit"), 
                      ")"), side = 2, col = 2, line = 2)
                    mtext("TimePoint", side = 4, col = 4, line = 0)
                    mtext(paste("(", attr(Tvector[[1]], "Unit"), 
                      ")"), side = 4, col = 2, line = 1)
                    Unit = attr(Mvector[[1]], "Unit")
                    if (is.null(Unit)) 
                      Unit = " "
                    if (length(unique(as.numeric(get(names(Mvector), 
                      Environment)))) > 7) {
                      Char = paste("From", ceiling(Colnum[[2]][1:7]), 
                        "to", ceiling(Colnum[[2]][2:8]), Unit)
                      print("Please mark one point for legend")
                      legend(locator(1), legend = Char, col = 1:7, 
                        pch = 16)
                    }
                    else {
                      if (is.numeric(get(names(Mvector), Environment))) {
                        print("Please mark one point for legend")
                        legend(locator(1), legend = paste(Colnum[[2]], 
                          Unit), col = seq(Colnum[[2]]), pch = 16)
                      }
                      else {
                        print("Please mark one point for legend")
                        legend(locator(1), legend = levels(get(names(Mvector), 
                          Environment))[Colnum[[2]]], col = seq(Colnum[[2]]), 
                          pch = 16)
                      }
                    }
                    browser()
                  }
                  else {
                    if (match("package:scatterplot3d", search(), 
                      0) == 0) {
                      library(scatterplot3d)
                    }
                    x = get(names(Pvector[1]), Environment)
                    z = get(names(Mvector), Environment)
                    y = get(names(Tvector), Environment)
                    scatterplot3d(x, y, z, , xlab = "", ylab = "", 
                      zlab = "", pch = 16, mar = c(7, 3, 5, 3))
                    mtext("PointProcess", outer = T, side = 3, 
                      cex = 2, col = 4)
                    mtext(attr(Mvector[[1]], "LongName"), side = 3, 
                      col = 3, cex = 1.5)
                    mtext(attr(Pvector[[1]], "LongName"), side = 1, 
                      col = 4, line = 2)
                    print(attr(Pvector[[1]], "Unit"))
                    if (length(attr(Pvector[[1]], "Unit")) > 
                      0) {
                      mtext(paste("(", attr(Pvector[[1]], "Unit"), 
                        ")"), side = 1, col = 2, line = 3)
                    }
                    mtext(attr(Mvector[[1]], "LongName"), side = 2, 
                      col = 4, line = 3)
                    mtext(paste("(", attr(Mvector[[1]], "Unit"), 
                      ")"), side = 2, col = 2, line = 2)
                    mtext("TimePoint", side = 4, col = 4, line = 0)
                    mtext(paste("(", attr(Tvector[[1]], "Unit"), 
                      ")"), side = 4, col = 2, line = 1)
                    Unit = attr(Mvector[[1]], "Unit")
                    if (is.null(Unit)) 
                      Unit = " "
                    browser()
                  }
                }
            }
            else {
                if (length(Pvector) == 2) {
                  x = get(names(Pvector[1]), Environment)
                  z = get(names(Pvector[2]), Environment)
                  y = get(names(Tvector), Environment)
                  Xlab = paste("Longitude (", attr(Pvector[[1]], 
                    "Unit"), ")")
                  Zlab = paste("Latitude (", attr(Pvector[[2]], 
                    "Unit"), ")")
                  Ylab = paste("TimePoint (", attr(Tvector[[1]], 
                    "Unit"), ")")
                  scatterplot3d(x, y, z, xlab = Xlab, ylab = Ylab, 
                    zlab = Zlab)
                  browser()
                }
                else {
                  plot(get(names(Tvector), Environment), get(names(Pvector), 
                    Environment))
                  browser()
                }
            }
        }
        else {
            Tlen = 1
            if (is.data.frame(Tvector)) {
                Tlen = sum(as.logical(apply(Tvector, 2, sum)))
                if (Tlen > 2) 
                  par(mar = c(Tlen + 1, 4, 4, 2))
                else {
                  Tlen = 5
                  par(mar = c(5, 4, 4, 2))
                }
            }
            if (length(markVectorNumber)) {
                for (k in 1:length(markVectorNumber)) {
                  Mvector = structure[markVectorNumber[k]]
                  print(1)
                  plot(seq(get(names(Mvector), Environment)), 
                    get(names(Mvector), Environment)[sort.list(get(names(Tvector), 
                      Environment))], xlab = "", ylab = "", xaxt = "n", 
                    cex = 0.5)
                  mtext("PointProcess", outer = T, side = 3, 
                    col = 4, cex = 2)
                  if (Tlen > 2) 
                    mtext("TimePoint", side = 1, line = Tlen + 
                      1, col = 4)
                  else {
                    mtext("TimePoint", side = 1, line = Tlen - 
                      1, col = 4)
                    mtext(paste("(", attr(Tvector[[1]], "Unit"), 
                      ")"), side = 1, line = Tlen, col = 2)
                  }
                  mtext(attr(Mvector[[1]], "LongName"), side = 2, 
                    col = 4, line = 3)
                  mtext(paste("(", attr(Mvector[[1]], "Unit"), 
                    ")"), side = 2, col = 2, line = 2)
                  browser()
                }
            }
            else {
                if (sum(condVectorNumber)) {
                  xy = split(get(names(Tvector), Environment), 
                    Sfactor)
                  xylen = length(xy)
                  print(xylen)
                  Ylim = range(unlist(lapply(xy, diff)))
                  MF = 1
                  if (xylen > 3) {
                    par(mfrow = c(2, 2))
                    MF = 4
                  }
                  else {
                    if (xylen > 1) {
                      par(mfrow = c(1, 2))
                      MF = 2
                    }
                  }
                  for (r in 1:xylen) {
                    print(length(Sfactor))
                    plot(xy[[r]], c(NA, diff(xy[[r]])), xlab = "", 
                      ylab = "", ylim = Ylim, cex = 0.5)
                    Scond = names(xy)[r]
                    Cond = substring(Scond, 2, nchar(Scond))
                    mtext("PointProcess", outer = T, side = 3, 
                      col = 4, cex = 2)
                    mtext(paste("Condition  =  (", substring(Cond, 
                      1, nchar(Cond)), ")"), col = 6, side = 3, 
                      cex = 1.2, line = 1)
                    mtext("TimePoint", side = 1, col = 4, line = 2)
                    mtext(paste("(", attr(Tvector[[1]], "Unit"), 
                      ")"), side = 1, col = 2, line = 3)
                    mtext("diff", side = 2, col = 4, line = 3)
                    if (r%%MF == 0) 
                      browser()
                  }
                }
                else {
                  plot(get(names(Tvector), Environment), c(NA, 
                    diff(get(names(Tvector), Environment))), 
                    xlab = "", ylab = "", cex = 0.5)
                  title("PointProcess", xlab = "TimePoint", ylab = "diff", 
                    col = 4, cex = c(2, 1, 1))
                  browser()
                }
            }
        }
    }
    else {
        if (length(pointVectorNumber)) {
            Pvector = structure[pointVectorNumber]
            if (length(markVectorNumber)) {
                for (k in 1:length(markVectorNumber)) {
                  Mvector = structure[markVectorNumber[k]]
                  if (length(Pvector) == 2) {
                    x = get(names(Pvector[1]), Environment)
                    y = get(names(Pvector[2]), Environment)
                    plot(x, y, type = "n")
                    text(x, y, get(names(Mvector), Environment))
                  }
                  else plot(get(names(Pvector), Environment), 
                    get(names(Mvector), Environment), cex = 0.5)
                  browser()
                }
            }
            else {
                if (length(Pvector) == 2) {
                  x = get(names(Pvector[1]), Environment)
                  y = get(names(Pvector[2]), Environment)
                  plot(x, y, cex = 0.5)
                }
                else {
                  plot(get(names(Pvector), Environment), c(NA, 
                    diff(get(names(Pvector), Environment))), 
                    cex = 0.5)
                }
                browser()
            }
        }
    }
    return()
}
