"Relational" <-
function(structure){
	getString(paste("doc=loadDocument(\"", structure[[1]][[3]], "\")",sep=""))
    Names = names(structure)
    
    dataVectorId = unlist(lapply(lapply(structure,attr,"Id"),function(x){if(is.null(x)){x="NULL"}else{x=x}}))
    Environment = attr(attr(structure, "Environment"), "name")
    Environment = match(Environment, search())
    
    Controllable = attr(structure, "Controllable")
    Nominal = attr(structure, "Nominal")
    Variable = attr(structure, "Variable")
    Block = attr(structure, "Block")
    Latent = attr(structure, "Latent")
    Auxiliary = attr(structure, "Auxiliary")
    
    #print(Environment)
    dataType = unlist(lapply(lapply(structure,attr,"DataType"),function(x){if(is.null(x)){x="NULL"}else{x=x}}))
    systemId = unlist(lapply(lapply(structure,attr,"Systems"),function(x){if(is.null(x)){x="NULL"}else{x=x}}))
	systemType = unlist(lapply(systemId, function(x){if(x=="NULL"){"NULL"}else{getString(paste("doc.getElementById(\"", x, "\").getNodeName()", sep=""))}}))
    Unit = unlist(lapply(lapply(structure,attr,"Unit"),function(x){if(is.null(x)){x="NULL"}else{x=x}}))
    Domain = unlist(lapply(lapply(structure,attr,"Domain"),function(x){if(is.null(x)){x="NULL"}else{x=x}}))
	
    unitDomain = paste(Unit, Domain, sep="+")
    #print(dataType)
    
    Calibration = function(Axis, Index=NULL){
    	valueLength = length(Axis)
    	if(!is.null(Index)){
			Axis = Axis[Index]
		}
		calib = c(1,1,1,valueLength)
		calib[2] = (Axis[valueLength] - Axis[1])/3 + Axis[1]
		calib[3] = (Axis[valueLength] - Axis[1])/3*2 + Axis[1]
		calib[2] = seq(valueLength)[Axis > calib[2]][1]
		calib[3] = seq(valueLength)[Axis > calib[3]][1]
		axis(1,Axis[calib],names(Axis)[calib])
	}
	
	axisLabel = function(xLabel=NULL, yLabel=NULL, xUnit=NULL, yUnit=NULL){
		if(!is.null(xUnit))
			if(xUnit != "Julian Day")
				mtext(paste("(", xUnit, ")"), col = 2, side = 1, line = 4)
		if(!is.null(yUnit))
			mtext(paste("(", yUnit, ")"), col = 2, side = 2, line = 2)
		if(!is.null(xLabel))
			mtext(xLabel, col = 4, line = 3, side = 1)
		if(!is.null(yLabel))
			mtext(yLabel, col = 4, line = 3, side = 2)
	}
	
    
    Unordered = NULL
    Ordered = NULL
    Logical = NULL

    EquiSpaced = NULL
    Interval = NULL

    Id = NULL
    Number = NULL
    Sequence = NULL

    Score = NULL
    Count = NULL

	Null = NULL

    len = length(structure)
    
    Unordered = seq(len)[dataType=="Unordered"]
    Ordered = seq(len)[dataType=="Ordered"]
    Logical = seq(len)[dataType=="Logical"]
    
    Null = seq(len)[dataType=="NULL"]
    EquiSpaced = seq(len)[dataType=="EquiSpaced"]
    Interval = seq(len)[dataType=="Interval"]
    
    Id = seq(len)[dataType=="Id"]
    Number = seq(len)[dataType=="Number"]
    Sequence = seq(len)[dataType=="Sequence"]
    
    Score = seq(len)[dataType=="Score"]
    Count = seq(len)[dataType=="Count"]
    
    
    Controllable = match(Controllable, dataVectorId)
    Nominal = match(Nominal, dataVectorId)
    Variable = match(Variable, dataVectorId)
    Block = match(Block, dataVectorId)
    Latent = match(Latent, dataVectorId)
    #Auxiliary = match(Auxiliary, dataVectorId)
    
    Factor = c(Controllable, Nominal, Variable, Latent)
    Value = setdiff(seq(len), Factor)
    Factor = union(Factor, Factor)
    
	if (length(Factor)) {#FACTOR
		#cat("Factor=");print(Factor)
		contFactor = intersect(Factor, c(Null, EquiSpaced, Interval))
		#print(contFactor)
		if(length(contFactor)){#CONTINUOUS FACTOR
			#print(systemType)
			
			discreteFactor = setdiff(Factor, c(contFactor, Id, Number, Sequence))
			
			unitDomain = paste(Unit, Domain)
			contValue = intersect(Value, c(Null, EquiSpaced, Interval))
			unitDomain = split(contValue, unitDomain[contValue])
			discreteValue = setdiff(Value, c(contValue, Id, Number, Sequence))
			#print(unitDomain)
			
			Label = NULL
			Condition = NULL
			internalCondition = NULL
			if (length(discreteValue) > 0) {
				if (length(discreteFactor) > 0) {#CONDITION and CATEGORY
					Label = discreteValue
					Condition = discreteFactor
				} else {#ONLY CATEGORY
					Label = discreteValue
				}
			} else {#NO CATEGORY
				if (length(discreteFactor) > 0) {#ONLY CONDITION
					unorderedFactor = intersect(discreteFactor, Unordered)
					orderedFactor = intersect(discreteFactor, Ordered)
					logicalFactor = intersect(discreteFactor, Logical)
					if(length(unorderedFactor)){
						if(length(orderedFactor)){
							if(length(logicalFactor)){
								internalCondition = orderedFactor
								Condition = c(logicalFactor, unorderedFactor)
							}else{
								internalCondition = orderedFactor
								Condition = unorderedFactor
							}
						}else{
							if(length(logicalFactor)){
								internalCondition = logicalFactor
								Condition = unorderedFactor
							}else{
								internalCondition = unorderedFactor
							}
						}
					} else {
						if(length(orderedFactor)){
							if(length(logicalFactor)){
								internalCondition = orderedFactor
								Condition = logicalFactor
							}else{
								internalCondition = orderedFactor
							}
						}else{
							if(length(logicalFactor)){
								internalCondition = logicalFactor
							}else{
								
							}
						}
					}
				}
			}
			
			if (sum(match(systemType[contFactor],"NULL",0)) < length(contFactor)) {#STRUCTURE
				cat("Structure=")
				strContFactor = Factor[!as.logical(match(systemType[contFactor],"NULL",0))]
				#strContFactor = intersect(contFactor, c())

				strContFactorSystem = systemType[strContFactor]
				strContFactorSystemId = systemId[strContFactor]
				
				strContFactorSystemList = split(strContFactor, strContFactorSystem)
				strContFactorSystemIdList = split(strContFactorSystemId, strContFactorSystem)
				#print(strContFactor)
				for(i in 1:length(strContFactorSystemIdList)){
					strContFactorSystemList[[i]] = split(strContFactorSystemList[[i]], strContFactorSystemIdList[[i]])
				}
				#cat("hoge");print(strContFactorSystemList)
				for(i in 1:length(strContFactorSystemList)){
					strContFactorSystemName = names(strContFactorSystemList)[i]
					print(strContFactorSystemName)
					if(strContFactorSystemName == "Time"){
						for(j in 1:length(strContFactorSystemList[[i]])){
							Axis = strContFactorSystemList[[i]][[j]]
							#cat("axis=");print(dataType[Axis][1])
							if (dataType[Axis][1] == "Interval") {
								if(length(Condition)){
									if(length(internalCondition)){#INTERVAL CONDITON INTERNAL
										conditionVector = NULL
										internalConditionVector = NULL
										for(k in 1:length(Condition)){
											conditionVector = paste(conditionVector, get(Names[Condition[k]], Environment), sep="+")
										}
										for(k in 1:length(internalCondition)){
											internalConditionVector = paste(internalConditionVector,
											 get(Names[internalCondition[k]], Environment), sep="+")
										}
										conditionVector = substring(conditionVector, 2)
										internalConditionVector = substring(internalConditionVector, 2)
										
										axisVector = split(get(Names[Axis], Environment), conditionVector)
										internalConditionVector = split(internalConditionVector, conditionVector)
										axisVectorTemp = axisVector
										for (k in 1:length(unitDomain)) {
											valueVector = lapply(unitDomain[[k]], function(x){get(Names[x], Environment)})
											valueVector = lapply(valueVector, function(x){split(x, conditionVector)})
											
											par(mfrow=c(1, 1), mar=c(0,0,0,0), oma=c(6,5,5,3))
											for(p in 1:length(unique(conditionVector))) {
												temp0 = unlist(lapply(valueVector, function(x){x[[p]]}))
												plot(rep(axisVector[[p]], length(unitDomain[[k]])),
												 temp0,
												  type="n", xaxt="n", xlab="", ylab="")
												
												Calibration(sort(axisVector[[p]]))
												axisLabel(attr(structure[[Axis]], "LongName"),,
												 attr(structure[[Axis]], "Unit"), attr(structure[[unitDomain[[k]][1]]], "Unit"))
												temp2 = split(axisVector[[p]], internalConditionVector[[p]])
												temp = lapply(valueVector, function(x){split(x[[p]], internalConditionVector[[p]])})
												#print(length(temp))
												for(q in 1:length(temp2)){
													
													boxplot( unlist(lapply(temp, function(x){x[[q]]}))
													 ~factor(rep(temp2[[q]], length(unitDomain[[k]]))),
													  add=T, at=sort(temp2[[q]]), xaxt="n", col=q)
												}
												mtext(names(internalConditionVector)[p], outer = T, side = 3, col = 1, cex = 2,line = 2)
												browser()
											}
										}
									}else{
										
									}
								}else{
									if(length(internalCondition)){
										
									}else{
										par(mfrow=c(length(unitDomain), 1), mar=c(0,0,0,0), oma=c(6,5,5,3))
										for (k in 1:length(unitDomain)) {
											plot(rep(get(Names[Axis], Environment), length(unitDomain[[k]])),
											 unlist(lapply(unitDomain[[k]], function(x){get(Names[x], Environment)})),
											  type="n", xaxt="n", xlab="", ylab="")
											
											Calibration(sort(get(Names[Axis], Environment)))
											
											boxplot(unlist(lapply(unitDomain[[k]], function(x){get(Names[x], Environment)}))
											 ~factor(rep(get(Names[Axis], Environment), length(unitDomain[[k]]))),
											  add=T, at=sort(get(Names[Axis], Environment)), xaxt="n")
											  
											axisLabel(attr(structure[[Axis]], "LongName"),,
											 attr(structure[[Axis]], "Unit"), attr(structure[[unitDomain[[k]][1]]], "Unit"))
											mtext(attr(structure, "LongName"), outer = T, side = 3, col = 1, cex = 2,line = 2)
											browser()
										}
									}
								}
							} else if (dataType[Axis][1] == "EquiSpaced") {
								if(length(Condition)){
									if(length(internalCondition)){
										unitDomain = unlist(unitDomain)
										conditionVector = NULL
										internalConditionVector = NULL
										for(k in 1:length(Condition)){
											conditionVector = paste(conditionVector, get(Names[Condition[k]], Environment), sep="+")
										}
										for(k in 1:length(internalCondition)){
											internalConditionVector = paste(internalConditionVector,
											 get(Names[internalCondition[k]], Environment), sep="+")
										}
										
										axisVector = split(get(Names[Axis], Environment), conditionVector)
										print("mae")
										internalConditionVector = split(internalConditionVector, conditionVector)
										print("ato")
										print("korekara")
										for (k in 1:length(unitDomain)) {
											valueVector = split(get(Names[unitDomain[k]], Environment), conditionVector)
											par(mfrow=c(length(unique(conditionVector)), 1))
											for(p in 1:length(unique(conditionVector))) {
												plot(axisVector[[p]], valueVector[[p]],
												 type="n", xaxt="n", xlab="", ylab="")
												
												Calibration(sort(get(Names[Axis], Environment)))
												axisLabel(attr(structure[[Axis]], "LongName"),attr(structure[[unitDomain[[k]]]], "LongName"),
												 attr(structure[[Axis]], "Unit"), attr(structure[[unitDomain[[k]]]], "Unit"))
												axisVector[[p]] = split(axisVector[[p]], internalConditionVector[[p]])
												valueVector[[p]] = split(valueVector[[p]], internalConditionVector[[p]])
												for(q in 1:length(axisVector[[p]])){
													points(axisVector[[p]][[q]], valueVector[[p]][[q]],
													 type="l", xaxt="n", col=q)
												}
												mtext(attr(structure, "LongName"), outer = T, side = 3, col = 1, cex = 2,line = 2)
												browser()
											}
										}
									}else{#ONLY CONDITION
										conditionVector = NULL
										for(k in 1:length(Condition)){
											conditionVector = paste(conditionVector, get(Names[Condition[k]], Environment), sep="+")
										}
										axisVector = split(get(Names[Axis], Environment), conditionVector)
										for (k in 1:length(unitDomain)) {
											valueVector = lapply(unitDomain[[k]], function(x){get(Names[x], Environment)})
											valueVector = lapply(valueVector, function(x){
												split(x, conditionVector)})
											#par(mfrow=c(length(unique(conditionVector)), 1))
											for(p in 1:length(unique(conditionVector))) {
												temp = NULL
												temp = unlist(lapply(valueVector, function(x){x[[p]]}))
												plot(rep(axisVector[[p]], length(unitDomain[[k]])),
												 temp, type="n", xaxt="n", xlab="", ylab="")
												
												Calibration(sort(get(Names[Axis], Environment)))
												axisLabel(attr(structure[[Axis]], "LongName"),,
												 attr(structure[[Axis]], "Unit"), attr(structure[[unitDomain[[k]][1]]], "Unit"))
												for(q in 1:length(valueVector)){
													points(axisVector[[p]], valueVector[[q]][[p]],
													 type="l", xaxt="n", col=q)
												}
												mtext(attr(structure, "LongName"), outer = T, side = 3, col = 1, cex = 2,line = 2)
												browser()
											}
										}
									}
								}else{
									if(length(internalCondition)){#ONLY INTERNALCONDITION
										internalConditionVector = NULL
										for(k in 1:length(Condition)){
											internalConditionVector = paste(internalConditionVector, get(Names[Condition[k]], Environment), sep="+")
										}
										axisVector = split(get(Names[Axis], Environment), internalConditionVector)
										for (k in 1:length(unitDomain)) {
											valueVector = lapply(unitDomain[[k]], function(x){get(Names[x], Environment)})
											valueVector = lapply(valueVector, function(x){
												split(x, internalConditionVector)})
											#par(mfrow=c(length(unique(internalConditionVector)), 1))
											for(p in 1:length(unique(internalConditionVector))) {
												temp = NULL
												temp = unlist(lapply(valueVector, function(x){x[[p]]}))
												plot(rep(axisVector[[p]], length(unitDomain[[k]])),
												 temp, type="n", xaxt="n", xlab="", ylab="")
												
												Calibration(sort(get(Names[Axis], Environment)))
												axisLabel(attr(structure[[Axis]], "LongName"),,
												 attr(structure[[Axis]], "Unit"), attr(structure[[unitDomain[[k]][1]]], "Unit"))
												for(q in 1:length(valueVector)){
													points(axisVector[[p]], valueVector[[q]][[p]],
													 type="l", xaxt="n", col=q)
												}
												mtext(attr(structure, "LongName"), outer = T, side = 3, col = 1, cex = 2,line = 2)
												browser()
											}
										}
									}else{#NO CONDITION INTERNALCONDITION
										axisVector = get(Names[Axis], Environment)
										for (k in 1:length(unitDomain)) {
											valueVector = lapply(unitDomain[[k]], function(x){get(Names[x], Environment)})
											#par(mfrow=c(length(unique(internalConditionVector)), 1))
											plot(rep(axisVector, length(unitDomain[[k]])),
											 unlist(valueVector), type="n", xaxt="n", xlab="", ylab="")
											
											Calibration(sort(get(Names[Axis], Environment)))
											axisLabel(attr(structure[[Axis]], "LongName"),,
											 attr(structure[[Axis]], "Unit"), attr(structure[[unitDomain[[k]][1]]], "Unit"))
											for(q in 1:length(valueVector)){
												points(axisVector, valueVector[[q]],
												 type="l", xaxt="n", col=q)
											}
											mtext(attr(structure, "LongName"), outer = T, side = 3, col = 1, cex = 2,line = 2)
											browser()
										}
									}
								}
							} else if (dataType[Axis][1] == "NULL") {
								if (sum(match(Latent, Axis, 0))) {################LATENT################
									if(length(Label)){
										unitDomain = unlist(unitDomain)
										par(mfrow=c(length(unitDomain), 1), mar=c(0,0,0,0), oma=c(6,5,5,3))
										for(p in 1:length(Label)){
											
											Col = as.factor(get(Names[Label[p]], Environment))
											colLevels = levels(Col)
											colSummary = sort(summary(Col),decreasing=T)
											Col = as.numeric(Col)
											
											if(sum(is.na(Col))){
												Col[seq(length(Col))[is.na(Col)]] = length(colLevels)+1
												colNumber = match(names(colSummary), c(colLevels, "NA's"))
												names(colNumber) = names(colSummary)
											}else{
												colNumber = match(names(colSummary), colLevels)
												names(colNumber) = names(colSummary)
											}
											
											if(length(colNumber) > 5){
												temp=0
												names(temp)="Other"
												colNumber = c(colNumber[1:4],temp)
											}
											
											for (l in 1:(length(unitDomain)-1)) {
												plot(get(Names[Axis], Environment),
												 get(Names[unitDomain[l]], Environment),
												  type="h", xaxt="n", xlab="", ylab="",
												   col=Col)
												  
												axisLabel(,attr(structure[[unitDomain[l]]], "LongName"),
												 , attr(structure[[unitDomain[l]]], "Unit"))
											}
											plot(get(Names[Axis], Environment),
											 get(Names[unitDomain[length(unitDomain)]], Environment),
											  type="h", xaxt="n", xlab="", ylab="",
											   col=Col)
											
											Calibration(sort(get(Names[Axis], Environment)))
											
											axisLabel(attr(structure[[Axis]], "LongName"),attr(structure[[unitDomain[length(unitDomain)]]], "LongName"),
											 attr(structure[[Axis]], "Unit"), attr(structure[[unitDomain[length(unitDomain)]]], "Unit"))
											mtext(attr(structure, "LongName"), outer = T, side = 3, col = 1, cex = 2,line = 2) 
											legend(locator(1),legend=names(colNumber),col=colNumber,lwd=1)
											browser()
										}
									}
								}
							}
						}
					} else if (strContFactorSystemName == "LongitudeLatitude"){
						for(j in 1:length(strContFactorSystemList[[i]])){
							ans = readline("Use Maptools?(y/n)")
							if(ans == "y"){
								library(maptools)
								jpn = read.shape("R/japan.shp")
							}
							LongitudeLatitude = attr(structure, "Systems")[[names(strContFactorSystemList[[i]])[j]]]
							Longitude = match(LongitudeLatitude[LongitudeLatitude$NodeName=="Longitude",]$RefId, dataVectorId)
							Latitude = match(LongitudeLatitude[LongitudeLatitude$NodeName=="Latitude",]$RefId, dataVectorId)
							if (dataType[Longitude][1] == "NULL") {
								if(length(Condition)){
									if(length(internalCondition)){#INTERVAL CONDITON INTERNAL
										conditionVector = NULL
										internalConditionVector = NULL
										for(k in 1:length(Condition)){
											conditionVector = paste(conditionVector, get(Names[Condition[k]], Environment), sep="+")
										}
										for(k in 1:length(internalCondition)){
											internalConditionVector = paste(internalConditionVector,
											 get(Names[internalCondition[k]], Environment), sep="+")
										}
										conditionVector = substring(conditionVector, 2)
										internalConditionVector = substring(internalConditionVector, 2)
										
										axisVector = split(get(Names[Axis], Environment), conditionVector)
										internalConditionVector = split(internalConditionVector, conditionVector)
										axisVectorTemp = axisVector
									} else {
										#NOTHING!!!!!
									}
								} else {
									if (length(internalCondition)) {
										
									} else {
										if(length(Label)){
											for(p in 1:length(Label)){
												par(mfrow=c(1, 1), mar=c(0,0,0,0), oma=c(6,5,5,3))
												Col = as.factor(get(Names[Label[p]], Environment))
												colLevels = levels(Col)
												colSummary = sort(summary(Col),decreasing=T)
												Col = as.numeric(Col)
												
												if(sum(is.na(Col))){
													Col[seq(length(Col))[is.na(Col)]] = length(colLevels)+1
													colNumber = match(names(colSummary), c(colLevels, "NA's"))
													names(colNumber) = names(colSummary)
												}else{
													colNumber = match(names(colSummary), colLevels)
													names(colNumber) = names(colSummary)
												}
												
												if(length(colNumber) > 5){
													temp=0
													names(temp)="Other"
													colNumber = c(colNumber[1:4],temp)
												}
												plot(jpn, 
												   xlim=range(get(Names[Longitude], Environment)),
												    ylim=range(get(Names[Latitude], Environment)),
												     xlab="", ylab="")
												box()
												points(get(Names[Longitude], Environment),
												 get(Names[Latitude], Environment),
												   col=Col)
												  
												axisLabel(attr(structure[[Longitude]], "LongName"), 
												 attr(structure[[Latitude]], "LongName"),,)
												mtext(attr(structure[[Label[p]]], "LongName"), outer = T, side = 3, col = 1, cex = 2,line = 2) 
												legend(locator(1),legend=names(colNumber),col=colNumber,pch=1)
												browser()
											}
										}
										unitDomain = unlist(unitDomain)
										par(mfrow=c(1, 1), mar=c(0,0,0,0), oma=c(6,5,5,3))
										
										valueVector = get(Names[unitDomain[p]], Environment)
										for (p in 1:(length(unitDomain))) {
											plot(jpn, xlim=range(get(Names[Longitude], Environment)),
											 ylim=range(get(Names[Latitude], Environment)),
											  xlab="", ylab="",)
											box()
											points(get(Names[Longitude], Environment),
											 get(Names[Latitude], Environment),
											  cex=(valueVector/diff(range(valueVector)))^2*5)
											  
											axisLabel(attr(structure[[Longitude]], "LongName"), 
											 attr(structure[[Latitude]], "LongName"),,)
											mtext(attr(structure[[unitDomain[p]]], "LongName"), outer = T, side = 3, col = 1, cex = 2,line = 2)
											Pch = floor(min(valueVector)):floor(max(valueVector))
											#legend(locator(1),legend=Pch,col=seq(length(Pch)),pch=1,cex=0.5, lwd=(Pch/diff(range(valueVector)))^2*5)
											browser()
										}
									}
								} 
							}
							
						}
					} else if (strContFactorSystemName == "Interval"){
						print("fuag")
					} else if (strContFactorSystemName == "OrthogonalCoordinate"){
						
					}
				}
			} else {#NO STRUCTURE
				
			}
		}
	}
}
