"TimeSeries" <-
function (structure) 
{
    Environment = attr(attr(structure, "Environment"), "name")
    Environment = match(Environment, search())
    Names = names(structure)
    dataVectorType = unlist(lapply(structure, attr, "DataVectorType"))
    systemsVectorNumber = seq(length(Names))[unlist(lapply(lapply(structure, 
        attr, "Systems"), is.null))]
    systemsVectorNumber = seq(length(dataVectorType))[-systemsVectorNumber]
    condVectorNumber = NULL
    conditionVector = list()
    temp = NULL
    if (sum(dataVectorType == "Condition")) {
        condVectorNumber = seq(dataVectorType)[dataVectorType == 
            "Condition"]
        if (length(systemsVectorNumber)) {
            longiCondVectorNumber = condVectorNumber[match(systemsVectorNumber, 
                condVectorNumber, 0)]
            condVectorNumber = condVectorNumber[-match(systemsVectorNumber, 
                condVectorNumber)]
            longiConditionVector = structure[longiCondVectorNumber]
            Lfactor = NULL
            for (i in 1:length(condVectorNumber)) Lfactor = c(paste(Lfactor, 
                get(Names[longiCondVectorNumber[i]], Environment), 
                sep = "->"))
            print(Lfactor[c(1:3)])
            Llen = length(unique(Lfactor))
            conditionVector = structure[condVectorNumber]
            Sfactor = NULL
            for (i in 1:length(condVectorNumber)) Sfactor = c(paste(Sfactor, 
                get(Names[condVectorNumber[i]]), sep = ","))
            Slen = length(unique(Sfactor))
            print(Sfactor[1])
        }
        else {
            conditionVector = structure[condVectorNumber]
            Sfactor = NULL
            for (i in 1:length(condVectorNumber)) Sfactor = c(paste(Sfactor, 
                get(Names[condVectorNumber[i]]), sep = ","))
            Slen = length(unique(Sfactor))
        }
    }
    timeAxisVectorNumber = seq(dataVectorType)[dataVectorType == 
        "TimeAxis"]
    valueVectorNumber = seq(dataVectorType)[dataVectorType == 
        "Value"]
    timeAxisVector = structure[timeAxisVectorNumber]
    if (length(timeAxisVector) > 1) {
        Tlen = sum(as.logical(apply(timeAxisVector, 2, sum)))
        par(mar = c(Tlen + 2, 4, 4, 2))
    }
    else Tlen = 3
    if (sum(condVectorNumber)) {
        splitedTimeVector = split(get(names(timeAxisVector)), 
            Sfactor)
        if (length(longiConditionVector)) {
            SLfactor = split(Lfactor, Sfactor)
        }
        splitedNumber = length(splitedTimeVector)
        MF = 1
        if (splitedNumber > 3) {
            par(mfrow = c(2, 2))
            MF = 4
        }
        else if (splitedNumber > 1) {
            par(mfrow = c(2, 1))
            MF = 2
        }
        for (i in 1:length(valueVectorNumber)) {
            valueVector = structure[[valueVectorNumber[i]]]
            Ylim = range(get(Names[valueVectorNumber[i]]))
            splitedValueVector = split(get(Names[valueVectorNumber[i]]), 
                Sfactor)
            for (r in 1:splitedNumber) {
                Lcond = NULL
                if (length(timeAxisVector) > 1) {
                  plot(seq(splitedValueVector[[r]]), splitedValueVector[[r]], 
                    xlab = "", ylab = "", xaxt = "n", type = "l", 
                    ylim = Ylim)
                  plotLab(splitedTimeVector[[r]])
                }
                else {
                  if (length(longiConditionVector)) {
                    plot(splitedTimeVector[[r]], splitedValueVector[[r]], 
                      xlab = "", ylab = "", type = "n", ylim = Ylim)
                    mtext(paste("(", attr(timeAxisVector[[1]], 
                      "Unit"), ")"), side = 1, line = Tlen, col = 2)
                    tempx = split(splitedTimeVector[[r]], SLfactor[[r]])
                    Lcond = lapply(tempx, mean)
                    Lcond = paste(names(sort(unlist(Lcond))), 
                      collapse = "")
                    tempy = split(splitedValueVector[[r]], SLfactor[[r]])
                    print(unique(SLfactor[[r]]))
                    for (k in 1:length(unique(SLfactor[[r]]))) {
                      points(tempx[[k]], tempy[[k]], col = k, 
                        type = "l")
                    }
                  }
                  else {
                    plot(splitedTimeVector[[r]], splitedValueVector[[r]], 
                      xlab = "", ylab = "", type = "l", ylim = Ylim)
                    mtext(paste("(", attr(timeAxisVector[[1]], 
                      "Unit"), ")"), side = 1, line = Tlen, col = 2)
                  }
                }
                Scond = names(splitedTimeVector)[r]
                Cond = substring(Scond, 1, nchar(Scond))
                mtext(paste("Condition =  (", substring(Cond, 
                  2, nchar(Cond)), ")"), col = 6, side = 3, cex = 1, 
                  line = 1)
                if (!is.null(Lcond)) {
                  mtext(paste("Longitudinal Condition =  (", 
                    substring(Lcond, 3, nchar(Lcond)), ")", sep = ""), 
                    col = 4, side = 1, cex = 1, line = 2)
                }
                mtext(attr(valueVector, "LongName"), side = 2, 
                  col = 4, line = 3)
                mtext(paste("(", attr(valueVector, "Unit"), ")"), 
                  side = 2, col = 2, line = 2)
                mtext("TimeSeries", outer = T, side = 3, col = 4, 
                  cex = 2)
                if (r%%MF == 0) 
                  browser()
            }
        }
    }
    else {
        for (i in 1:length(valueVectorNumber)) {
            valueVector = structure[[valueVectorNumber[i]]]
            if (length(timeAxisVector) > 1) {
                plot(seq(valueVector), valueVector, xlab = "", 
                  ylab = "", xaxt = "n", type = "l")
                plotLab(timeAxisVector)
            }
            else {
                plot(timeAxisVector, valueVector, xlab = "", 
                  ylab = "", type = "l")
                mtext(attr(timeAxisVector[[1]], "Unit"), side = 1, 
                  line = Tlen)
            }
            mtext("TimeSeries", side = 3, outer = T, col = 4, 
                cex = 2)
            mtext(attr(valueVector, "LongName"), side = 2, col = 4, 
                line = 3)
            mtext(paste("(", attr(valueVector, "Unit"), ")"), 
                side = 2, col = 2, line = 2)
            browser()
        }
    }
    return()
}
