"getDataVector" <-
function (valueId, where, variableType, langNum, naList = NULL) 
{
	if (is.null(variableType)) {
		variableType = ""
	}
	#getString(paste("doc=loadDocument(\"", where, "\")", sep = ""))
	
	if (length(grep("http", where))) {
        value = getString(paste("doc=loadDocument(\"", where, 
            "\")", sep = ""))
  } else {
        value = getStringLocal(paste("doc=loadDocument()", sep = ""), 
            where)
  }
	dataVectorNumber = getString(paste("doc.getElementById(\"", valueId, "\").getAttribute(\"RefId\")", sep = ""))
	if (dataVectorNumber == "") {
		dataVectorNumber = as.character(valueId)
	}
	else {
		dataVectorNumber = as.character(unlist(strsplit(dataVectorNumber, " ")))
	}
	dataVector = list()
	dataVector2 = list()
	Code = list(Code=NULL, Rank=NULL)
	Range = data.frame(Max=NULL, Min=NULL)
	if (length(dataVectorNumber) > 0) {
		uniqueDVN = as.character(unique(dataVectorNumber))
		for (i in 1:length(uniqueDVN)) {
			getString(paste("dataVectorNode=doc.getElementById(\"", uniqueDVN[i], "\")", sep = ""))
			dataVectorString = getString("getValue(dataVectorNode)")
			codeString = getString("dataVectorNode.getAttribute(\"Code\")")
			rangeString = getString("dataVectorNode.getAttribute(\"Range\")")
			if(codeString != ""){
				codeString = unlist(strsplit(codeString, " "))
				codeId = codeString[codeString != " "]
				if (length(codeId) > 1) {
				  codeId = codeId[langNum]
				}
				hoge = getString(paste("codeNode=doc.getElementById(\"", codeId, "\")", sep = ""))
				codeString = unlist(strsplit(getString("getValue(codeNode)"), "\""))
				orderedId = getString("codeNode.getAttribute(\"Order\")")
				Code[[1]][[as.character(uniqueDVN[i])]] = codeString[codeString != " " & codeString != ""]
				#print(codeString)
				if (orderedId != "") {
				  #orderedString = getString(paste("getValue(doc.getElementById(\"", orderedId, "\"))", sep = ""))
				  #orderedString = unlist(strsplit(orderedString, " "))
				  if(orderedId =="ascending"){
						Code[[2]][[as.character(uniqueDVN[i])]] = seq(Code[[1]][[as.character(uniqueDVN[i])]])
					}else if(orderedId =="descending"){
						Code[[2]][[as.character(uniqueDVN[i])]] = rev(seq(Code[[1]][[as.character(uniqueDVN[i])]]))
					}
				}
			} else {
				codeString = NULL
			}
			dataVectorString = unlist(strsplit(dataVectorString, " "))
			dataVectorString = dataVectorString[dataVectorString != ""]
			if (rangeString != "") {
				rangeString = unlist(strsplit(rangeString, " "))
				rangeString = rangeString[rangeString != ""]
				for(j in 1:length(rangeString)){
					hoge = getString(paste("rangeNode=doc.getElementById(\"", rangeString[j], "\")", sep = ""))
					maxv = as.numeric(c(getString("rangeNode.getAttribute(\"Sup\")"), getString("rangeNode.getAttribute(\"Max\")")))
					minv = as.numeric(c(getString("rangeNode.getAttribute(\"Inf\")"), getString("rangeNode.getAttribute(\"Min\")")))
					#Range = rbind(Range, data.frame(Id=as.character(uniqueDVN[i]), Max=max(maxv, na.rm=T), Min=min(minv, na.rm=T)))
					Range = rbind(Range, data.frame(Max=max(maxv, na.rm=T), Min=min(minv, na.rm=T)))
				}
			}
			dataVector[[as.character(uniqueDVN[i])]] = dataVectorString
		}
		if(length(Code[[1]])){
			Code[[1]] = Code[[1]][dataVectorNumber]
		}
		if(length(Code[[2]])){
			Code[[2]] = Code[[2]][dataVectorNumber]
		}
		if(length(Range)){
			#Range = Range[dataVectorNumber]
		}
		if (0) { # Missing and Invalid
			for (i in 1:length(naList)) {
				dataVector[[names(naList)[i]]] = dataVector[[names(naList)[i]]][-naList[[i]]]
			}
		}
		if (length(rangeString) > 0 & length(codeString) == 0 & variableType != "Mark") { # Numeric or Logical
			if (variableType == "Logical") {
				dataVector = as.logical(as.numeric(unlist(dataVector[dataVectorNumber])))
			} else {
				dataVector = dataVector[dataVectorNumber]
				dataVector = as.numeric(unlist(dataVector[dataVectorNumber]))
				if(dim(Range)[1]>0){
					rownames(Range) = 1:dim(Range)[1]
					attr(dataVector, "Range") = Range
				}
			}
		} else { # Otherwise
			dataVector = dataVector[dataVectorNumber]
			if (length(Code[[2]]) == 0 & length(Code[[1]]) > 0) {
				for (i in 1:length(dataVectorNumber)) {
				  dataVector[[i]] = Code[[1]][[i]][as.numeric(dataVector[[i]])]
				}
				dataVector = factor(unlist(dataVector), levels = unique(unlist(Code[[1]])))
			} else if (length(Code[[2]][[i]])) {
				dataVector = factor(Code[[1]][[i]][as.numeric(unlist(dataVector))], levels = Code[[1]][[1]][Code[[2]][[i]]], ordered = T)
			} else {
				#dataVector = factor(as.numeric(unlist(dataVector)))
				dataVector = factor(unlist(dataVector))
			}
		}
	}
	else {
		stop("No Data Vector")
	}
	return(dataVector)
}

