makeDandD=function(x, pkey=0){
	
	ej = function(name){paste(paste(name, c("E","J"), sep=""), collapse=" ")}
	
	catCode = function(cc){
		for(j in 1:length(cc)){
			if(is.ordered(cc[[j]])){
				cat(paste(c("
<Code Id=\"", names(cc)[j], "\" Length=\"", length(cc[[j]]), "\" Rank=\"", paste(names(cc)[j],"Rank",sep=""), "\">\n", 
paste(paste("\"", cc[[j]], "\"", sep=""), collapse=" "), "
</Code>"), collapse=""), file=paste(obname, ".dad", sep=""), append=T)
			}else{
				cat(paste(c("
<Code Id=\"", names(cc)[j], "\" Length=\"", length(cc[[j]]), "\">\n", 
paste(paste("\"", cc[[j]], "\"", sep=""), collapse=" "), "
</Code>"), collapse=""), file=paste(obname, ".dad", sep=""), append=T)
			}
		}
	}
	
	catRange = function(cc){
		for(j in 1:length(cc)){
			cat(paste(c("
<Range Id=\"", names(cc)[j], "\" Sup=\"", max(cc[[j]]), "\" Inf=\"", min(cc[[j]]), "\" />\n"
), collapse=""), file=paste(obname, ".dad", sep=""), append=T)
		}
	}
	
	catLongName = function(cc){
		for(j in 1:length(cc)){
			cat(paste(c("
<Name Id=\"", paste(cc[j], "LongNameE", sep=""), "\">\n", 
cc[j], "
</Name>"), collapse=""), file=paste(obname, ".dad", sep=""), append=T)
			cat(paste(c("
<Name Id=\"", paste(cc[j], "LongNameJ", sep=""), "\">\n", 
cc[j], "
</Name>"), collapse=""), file=paste(obname, ".dad", sep=""), append=T)
		}
	}
	
	Colnames=names(x)
	obname = deparse(substitute(x))
	unlink(paste(obname, ".dad", sep=""))
	cat(paste(c("<?xml version =\"1.0\" ?>

<!DOCTYPE DandD  SYSTEM \"http://www.stat.math.keio.ac.jp/DTD/DandD_3.0.3.dtd\"[]>

<DandD> 

<Title Title=\"titleE titleJ\" Language=\"English Japanese\" />

<BackGround>
	<Introduction Introduction=\"introductionE introductionJ\" />
	<Reference RefId=\"referenceE referenceJ\" />
</BackGround>

<Data>
	<Relation Id=\"", obname, "\" LongName=\"", ej(paste(obname, "LongName",sep="")), "\" ShortName=\"", obname, "\" TargetObject=\"TargetE TargetJ\" Columns=\"", paste(Colnames, collapse=" "), "\"", 
	ifelse(pkey, paste(" PrimaryKey=\"", paste(Colnames[pkey], collapste=" "), "\"", sep=""), ""),
	"/>
</Data>"), collapse=""), file=paste(obname, ".dad", sep=""), append=T)
	
	
	
	
	
	Code = list()
	Range= list()
	
	cat("\n<DataBody>\n\n", file=paste(obname, ".dad", sep=""), append=T)
	
	for(i in 1:(dim(x)[2])){
		if(is.logical(x[[i]])){
			
			cat(paste(c("\n\t<DataVector Id=\"", Colnames[i], "\" DataType=\"Logical\" LongName=\"", ej(paste(Colnames[i], "LongName", sep="")), "\" ShortName=\"", Colnames[i], "\">\n",
paste(as.numeric(x[[i]]), collapse=" "), "\n\t</DataVector>\n\n"), collapse=""), file=paste(obname, ".dad", sep=""), append=T)

		}else if(is.ordered(x[[i]])){
			
			Code[[paste(Colnames[i],"Code",sep="")]] = unique(x[[i]])
			cat(paste(c("\n\t<DataVector Id=\"", Colnames[i], "\" DataType=\"Mark\" LongName=\"", ej(paste(Colnames[i], "LongName", sep="")), "\" ShortName=\"", Colnames[i], "\" Code=\"", paste(Colnames[i],"Code",sep=""), "\">\n",
paste(as.numeric(x[[i]]), collapse=" "), "\n\t</DataVector>\n\n"), collapse=""), file=paste(obname, ".dad", sep=""), append=T)

			cat(paste(c("\n\t<DataVector Id=\"", paste(Colnames[i],"Rank",sep=""), "\" DataType=\"Ordinal\" LongName=\"", ej(paste(Colnames[i], "RankLongName", sep="")), "\" ShortName=\"", paste(Colnames[i], "Rank", sep=""), "\">\n",
paste(as.numeric(x[[i]]), collapse=" "), "\n\t</DataVector>\n\n"), collapse=""), file=paste(obname, ".dad", sep=""), append=T)

		}else if(is.factor(x[[i]])){
			
			Code[[paste(Colnames[i],"Code",sep="")]] = levels(x[[i]])
			cat(paste(c("\n\t<DataVector Id=\"", Colnames[i], "\" DataType=\"Mark\" LongName=\"", ej(paste(Colnames[i], "LongName", sep="")), "\" ShortName=\"", Colnames[i], "\" Code=\"", paste(Colnames[i],"Code",sep=""), "\">\n",
paste(as.numeric(x[[i]]), collapse=" "), "\n\t</DataVector>\n\n"), collapse=""), file=paste(obname, ".dad", sep=""), append=T)

		}else if(is.integer(x[[i]])){
			
			Range[[paste(Colnames[i],"Range",sep="")]] = range(x[[i]],na.rm=T)
			cat(paste(c("\n\t<DataVector Id=\"", Colnames[i], "\" DataType=\"Cardinal\" LongName=\"", ej(paste(Colnames[i], "LongName", sep="")), "\" ShortName=\"", Colnames[i], "\" Range=\"", paste(Colnames[i],"Range",sep=""), "\">\n",
paste(as.numeric(x[[i]]), collapse=" "), "\n\t</DataVector>\n\n"), collapse=""), file=paste(obname, ".dad", sep=""), append=T)

		}else{
			
			Range[[paste(Colnames[i],"Range",sep="")]] = range(x[[i]])
			cat(paste(c("\n\t<DataVector Id=\"", Colnames[i], "\" DataType=\"Measurement\" LongName=\"", ej(paste(Colnames[i], "LongName", sep="")), "\" ShortName=\"", Colnames[i], "\" Range=\"", paste(Colnames[i],"Range",sep=""), "\">\n",
paste(as.numeric(x[[i]]), collapse=" "), "\n\t</DataVector>\n\n"), collapse=""), file=paste(obname, ".dad", sep=""), append=T)
		}
		
	}
	
	cat("\n</DataBody>\n\n", file=paste(obname, ".dad", sep=""), append=T)
	
	
	
	cat(paste(c("<Appendix>

<Text Id=\"titleE\">\n", 
obname, "
</Text>
<Text Id=\"titleJ\">\n", 
obname, "
</Text>

<Name Id=\"TargetE\">\n",
obname, "
</Name>
<Name Id=\"TargetJ\">\n",
obname, "
</Name>

<Text Id=\"introductionE\">\n",
obname,"
</Text>
<Text Id=\"introductionJ\">\n",
obname, "
</Text>"), collapse=""), file=paste(obname, ".dad", sep=""), append=T)
	
	if(length(Code)){
		catCode(Code)
	}
	if(length(Range)){
		catRange(Range)
	}
	catLongName(c(obname,Colnames))
	
	
	cat(paste(c("
</Appendix>

</DandD>"), collapse=""), file=paste(obname, ".dad", sep=""), append=T)
	
	
	
	
	
	
	
	
}
