textile=function (dad, piece = 1, line = T, lcol = "gray", point = T, cex = NULL, mag = NULL, ord = T, ID = F, title, lty = 1, weft.width = 1, scaling=T, method="single") 
{
	clus=0
	#ID.default = ID
	point.default = point
	line.default = line
	ord.default = ord
	piece.default = piece
	piece.old=piece
	add = F
	na.rm = F
	lwd = 1
	PDF = F
	if (PDF) {
		cat("Tranceparency Level (%) = ")
		alpha = as.numeric(readline())
		pdf("alpha.pdf", version = "1.4", width = 10, height = 4)
	}
	ura = list()
	if (is.data.frame(dad)) {
		targetObject = "Object"
		weightNum = NA
		dad = data.frame(cbind(row.names(dad), dad))
		pkey = 1
		longName = names(dad)
		longName[1] = "Object ID"
		ura = dad
		unit = rep(NA, dim(ura)[2])
		variableType = rep("Measurement", dim(dad)[2])
		for (i in 1:dim(dad)[2]) {
			if (is.logical(dad[[i]])) {
				variableType[i] = "Logical"
			}
			else if (is.ordered(dad[[i]])) {
				variableType[i] = "OrderedMark"
			}
			else if (is.factor(dad[[i]])) {
				variableType[i] = "Mark"
			}
		}
	}
	else {
		targetObject = attr(dad, "TargetObject")
		pkey = attr(dad, "PrimaryKey")
		if (!is.null(pkey)) {
			if (length(pkey) > 1) {
				pkey = 0
			}
			else {
				pkey = match(pkey, names(dad))
			}
		}
		else {
			pkey = 0
		}
		ura = data.frame(lapply(as.list(names(dad)), get, envir = attributes(dad)$Env))
		title = attr(dad, "LongName")
		variableType = unlist(lapply(dad, function(y) {
			attr(y, "DataType")
		}))
		weightNum = match("Classified", variableType)
		longName = unlist(lapply(dad, function(y) {
			attr(y, "LongName")
		}))
		unit = unlist(lapply(dad, function(y) {
			if (!is.null(attr(y, "Unit"))) {
				attr(y, "Unit")
			}
			else if (!is.null(attr(y, "Numeral"))) {
				attr(y, "Numeral")
			}
			else {
				NA
			}
		}))
	}
	if (pkey) {
		IDlabel = as.character(ura[[pkey]])
		ura = ura[-pkey]
		variableType = variableType[-pkey]
		IDlongName = longName[pkey]
		longName = longName[-pkey]
		unit = unit[-pkey]
	}
	else {
		IDlabel = as.character(1:(dim(ura)[1]))
		IDlongName = paste(targetObject, "ID")
	}
	if (!is.na(weightNum)) {
		weight = ura[[weightNum]]
		ura = ura[-weightNum]
		variableType = variableType[-weightNum]
		longName = longName[-weightNum]
		unit = unit[-weightNum]
	}
	else {
		weight = rep(1, dim(ura)[1])
	}
	if (sum(apply(is.na(ura), 2, sum)) == 0) {
		na.rm = T
	}
	if (is.null(mag)) {
		mag = 1
	}
	if (is.null(lwd)) {
		lwd = 1
	}
	if (is.null(cex)) {
		cex = min(sqrt(5/length(ura)), 1)
	}
	weft = rep(T, length(ura[[1]]))
	warp = rep(T, length(ura))
	weft.old = rep(T, length(ura[[1]]))
	warp.old = rep(T, length(ura))
	weft.new = rep(T, length(ura[[1]]))
	warp.new = rep(T, length(ura))
	
	exit.status = 99
	weight.default = weight
	ura.default = ura
	funcs.default = list(function(x){x})[rep(1,dim(ura)[2])]
	funcs=funcs.default
	funcs.inv = funcs.default
	longName.default = longName
	unit.default = unit
	variableType.default = variableType
	while (exit.status > 0) {
		visible=F
		visible2=F
		visible3=F
		visible.clus=F
		ID.default = ID
		weight = weight.default[weft]
		ura = ura.default[weft, warp]
		for(k in 1:length(funcs[warp])){
			if(is.numeric(ura[[k]])){
				
				ura[[k]]=funcs[warp][[k]](ura[[k]])
			}
		}
		
		#print(as.numeric(unlist(lapply(ura,function(unis){length(unique(unis[!is.na(unis)]))-1}))))
		if(scaling){
			xx = parnew5(ura, ord, piece, weight)
		}else{
			xx = parnew5(ura, ord, piece, weight)
			xx[[1]]=rank(xx[[1]])
			xx[[1]]=(xx[[1]]-min(xx[[1]],na.rm=T))/abs(diff(range(xx[[1]], na.rm=T)))
			for(k in 2:dim(xx)[2]){
				#print(k)
				if(is.numeric(ura[[k-1]])){
					xx[[k]]=(xx[[k]]-min(xx[[k]],na.rm=T))/abs(diff(range(xx[[k]], na.rm=T)))
				}else{
					xx[[k]] = rank(xx[[k]])
					xx[[k]]=(xx[[k]]-min(xx[[k]],na.rm=T))/abs(diff(range(xx[[k]], na.rm=T)))
				}
			}
		}
		
		ura = ura.default[weft, warp]
		if (ID) {
			ran = range(c(unlist(xx[, ])), na.rm = T)
			xx = data.frame(lapply(xx, function(xxx) {(xxx - ran[1])/diff(ran) * 0.9 + 0.05}))
			y0 = as.numeric(xx[[1]])
			xx = xx[-1]
		}
		else {
			ran = range(c(unlist(xx[, -1])), na.rm = T)
			xx = data.frame(lapply(xx, function(xxx) {(xxx - ran[1])/diff(ran) * 0.9 + 0.05}))
			y0 = as.numeric(xx[[1]])
			xx = xx[-1]
		}
		xx.default = xx
		dataFrame = list()
		for (i in 1:length(xx)) {
			if (sum(!is.na(ura[[i]]))) {
				ura[[i]][is.na(ura[[i]])]=NA
				temp = split(xx[[i]], as.character(ura[[i]]))
				temp2 = split(weight, as.character(ura[[i]]))
				multi = unlist(lapply(temp2, sum))
				posi = unlist(lapply(temp, unique))
				data = names(temp)
				if (!is.factor(ura[[i]])) {
					if (!is.null(names(ura[[i]]))) {
					label = unlist(lapply(split(names(ura[[i]]), 
						ura[[i]]), unique))
					}
					else {
					label = data
					}
				}
				else {
					revPosi = cor(seq(length(posi)), (posi))
					label = levels(ura[[i]])
					Posi = rep(0, length(label))
					Multi = rep(0, length(label))
					Posi[match(data, label)] = posi
					Posi[-match(data, label)] = NA
					revPosi = cor(seq(length(Posi[!is.na(Posi)])), 
					-Posi[!is.na(Posi)])
					Multi[match(data, label)] = multi
					posi = Posi
					multi = Multi
					data = label
					if (is.ordered(ura[[i]])) {
					if (revPosi > 0 || is.na(revPosi)) {
						posi = lip(c(1, posi, 0))
					}
					else {
						posi = lip(c(0, posi, 1))
					}
					}
					else {
					posi[is.na(posi)] = 1 - seq(sum(is.na(posi)))/10/sum(is.na(posi))
					}
				}
				if (sum(is.na(ura[[i]]))) {
					multi = c(multi, sum(weight[is.na(ura[[i]])]))
					posi = c(posi, -0.1)
					label = c(label, "NA")
					data = c(data, NA)
				}
				names(multi) = NULL
				names(posi) = NULL
				names(label) = NULL
				names(data) = NULL
				dataFrame[[i]] = data.frame(multi = multi, posi = posi, 
					data = data, label = label)
			}
			else {
				dataFrame[[i]] = data.frame(multi = length(ura[[i]]), 
					posi = -0.1, data = NA, label = "NA")
			}
		}
		dataFrame.default = dataFrame
		max.nchar = max(nchar(c(IDlongName, longName, unit)))
		if (ID) {
			max.leftnchar = max(nchar(c(IDlongName)))
		}
		else {
			max.leftnchar = max(nchar(c(longName[1], unit[1])))
		}
		dd = dim(ura)
		if (ID) {
			xlim.default = c(min(-0.7, -0.3 * sqrt(max.nchar) * (sqrt(cex))/2) - 0.05, dd[2] + 0.5)
		}
		else {
			xlim.default = c(min(-0.7, -0.3 * sqrt(max.nchar) * (sqrt(cex))/2) + 0.95, dd[2] + 0.5)
		}
		
		xlim.default = c(min(-0.7, -0.3 * sqrt(max.nchar) * (sqrt(cex))/2) - 0.05, dd[2] + 0.5)
		
		xPosi = 1:(dd[2])
		if (na.rm) {
			ylim.default = c(-0.3 * sqrt(max.nchar) * (sqrt(cex))/3, 1.20)
			na.posi = 0.2
		} else {
			ylim.default = c(-0.3 * sqrt(max.nchar) * (sqrt(cex))/3 - 0.15, 1.20)
			na.posi = 0.05
		}
		IDwarp = F
		warp.sel = rep(F, dim(xx)[2])
		weft.sel = rep(F, dim(xx)[1])
		opr=0
		IDweft = weft.sel
		Point = matrix(rep(F, prod(dim(xx))), dim(xx)[1])
		active.default = c("black", lcol, "black", "black")
		active = active.default
		inactive = active
		inactive.default = active
		lcol.default = lcol
		cex.default = cex
		xlim = xlim.default + c(!ID, 0)
		ylim = ylim.default + c(0, clus)
		bcol = c(rep("black", 4), rep("#999999", 6))
		bcol.default = bcol
		bcol3= rep("#999999",5)
		bcol3.default=bcol3
		point.default = point
		line.default = line
		
		variableOrder = 1:(dim(xx)[2])
		
		while (exit.status) {
			bcol2 = rep("black", 6)
			btext2 = c("No ID Warp", "Default", "Variance", "Cluster", "No weft", "No Point")
			if (ID) {
				bcol2[1] = "#669999"
				btext2[1] = "ID Warp"
			}
			warp.sel = warp.sel[order(variableOrder)]
			if (ord == 0) {
				
				bcol2[2] = "#669999"
				variableOrder = 1:(dim(xx)[2])
			}else if (ord == 1) {
				bcol2[3] = "#669999"
				variableOrder = order(apply(xx.default, 2, Var), decreasing = T)
			}
			else if (ord == 2) {
				bcol2[4] = "#669999"
				btext2[4]=method
				xx.h = abss(xx.default, method)
				variableOrder = xx.h$order
			}
			
			warp.sel = warp.sel[variableOrder]
			ura = (ura.default[weft, warp])[, variableOrder]
			ura.attr=lapply(ura.default[,warp],function(urai){attr(urai, "Range")})[variableOrder]
			xx = xx.default[, variableOrder]
			dataFrame = dataFrame.default[variableOrder]
			longName = longName.default[warp][variableOrder]
			variableType = variableType.default[warp][variableOrder]
			unit = unit.default[warp][variableOrder]
			
			
			
			if (line == 2) {
				btext2[5] = "Thick weft"
				bcol2[5] = "#669999"
			}
			else if (line == 1) {
				btext2[5] = "Thin weft"
				bcol2[5] = "#669999"
			}
			if (point) {
				btext2[6] = "Point"
				bcol2[6] = "#669999"
			}
			par(mfcol = c(1, 1))
			par(mar = c(0, 0, 0, 0))
			par(oma = c(0, 0, 0, 0))
			temp1 = 0.03 * diff(ylim)
			temp2 = c(1:4) * 0.13 * diff(xlim)
			temp3 = c(1:6) * 0.13 * diff(xlim)
			cex.menu = 0.8
			plot(1, type = "n", ylim = ylim + c(-temp1, temp1), xlim = xlim, axes = F, xaxs = "i", yaxs = "i")
			if(clus){
				if(method=="kumasaka" && sum(variableOrder!=xx.h$order)){
					xx.h=minDist(xx.default, variableOrder)
				}
				vclust(xx.h, variableOrder=variableOrder, clus=clus, method=method, cex=cex)
			}
			
			text(xlim[2], ylim[2]-0.05, title, pos = 2, cex = min(2,15/nchar(title)), col = "navy")
			text(xlim.default[1]+0.05+!ID, 0.5, targetObject, pos = 4, col="navy", srt=90, cex=cex)
			
			
			
			
			all.posi = unlist(lapply(dataFrame, function(tableX) {tableX$posi}))
			all.multi = unlist(lapply(dataFrame, function(tableX) {tableX$multi}))
			all.xPosi = rep(xPosi, unlist(lapply(dataFrame, function(tableX) {dim(tableX)[1]})))
			mag.max = max(max(all.multi),49*mag^2)
			
			
			all.text = NULL
			all.text.posi = NULL
			all.text.xPosi = NULL
			all.text.col = NULL
			all.text.cposi = NULL
			
			
			
			
			
			
			
			
			
			
			
			segment.xPosi1 = NULL
			segment.yPosi1 = NULL
			segment.xPosi2 = NULL
			segment.yPosi2 = NULL
			segment.lwd = NULL
			weft.width = 1
			if (line) {
				if (PDF) {
					matpoints(ifelse(ID, c(0, xPosi), xPosi), ifelse(ID, t(cbind(y0, xx)), t(xx)), col = rgb(0, 0, 1, alpha), type = "l", lty = lty, lwd = lwd)
				}
				else {
					if (sum(!weft.sel)) {
						if (ID) {
							matpoints(c(0, xPosi[1]), t(cbind(y0[!weft.sel], xx[!weft.sel, 1])), col = inactive[2], type = "l", lty = lty, lwd = lwd * weft.width)
						}
						if (line > 1) {
							segment.xPosi1 = NULL
							segment.yPosi1 = NULL
							segment.xPosi2 = NULL
							segment.yPosi2 = NULL
							segment.lwd = NULL
							for (i in 1:(dim(xx)[2] - 1)) {
							xt = table(xx[, i], xx[, i + 1])
							if (sum(c(xt))) {
								xxt = as.logical(is.na(xx[, i]) + is.na(xx[, i + 1]))
								ddd = dim(xt)
								xtn = dimnames(xt)
								xtn[[1]] = as.numeric(rep(xtn[[1]], ddd[2]))
								xtn[[2]] = as.numeric(rep(xtn[[2]], rep(ddd[1], ddd[2])))
								xtn[[3]] = c(xt)
								xtn = data.frame(xtn)
								xtn = xtn[xtn[[3]] > 0, ]
								ddd = dim(xtn)
								segment.xPosi1 = c(segment.xPosi1, rep(xPosi[i], ddd[1]))
								segment.yPosi1 = c(segment.yPosi1, xtn[[1]])
								segment.xPosi2 = c(segment.xPosi2, rep(xPosi[i + 1], ddd[1]))
								segment.yPosi2 = c(segment.yPosi2, xtn[[2]])
								segment.lwd = c(segment.lwd, xtn[[3]])
							}
						}
						weft.width = 25/max(segment.lwd)
						if(min(segment.lwd)*lwd*weft.width>1){
							weft.width = weft.width/(min(segment.lwd)*lwd*weft.width)
						}
						segments(segment.xPosi1, segment.yPosi1, 
						segment.xPosi2, segment.yPosi2, lwd = segment.lwd * lwd * weft.width, lty = lty, col = inactive[2])
					}
					else {
						matpoints(xPosi, t(xx[!weft.sel, ]), col = inactive[2], type = "l", lty = lty, lwd = lwd * weft.width)
					}
					}
				}
			}
			if(sum(weft.sel)){
				if (point) {
					points(all.xPosi, all.posi, cex = sqrt(all.multi/mag.max) * 7 * mag, lwd = lwd, col = inactive[3])
				}
			}
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			for (i in 1:length(xx)) {
				posi = 0
				if (variableType[i] == "Logical") {
					tableX = dataFrame[[i]]
					all.text = c(all.text, as.character(tableX$label))
					all.text.posi = c(all.text.posi, tableX$posi)
					all.text.xPosi = c(all.text.xPosi, rep(xPosi[i], length(tableX$posi)))
					all.text.col = c(all.text.col, ifelse(rep(warp.sel[i], 
					length(tableX$posi)), rep(active[1], length(tableX$posi)), 
					c("black", rep("black", length(tableX$posi) - 1))))
					all.text.cposi = c(all.text.cposi, rep(0, length(tableX$posi)))
					if (point) {
						if (sum(weft.sel)) {
							points(xPosi[i], tableX$posi[1], cex = sqrt(tableX$multi/mag.max)[1] * 
							7 * mag, lwd = lwd, col = "#efefef", 
							pch = 21, bg = "#efefef")
						}
						else {
							points(xPosi[i], tableX$posi[1], cex = sqrt(tableX$multi/mag.max)[1] * 
							7 * mag, lwd = lwd, col = 1, pch = 21, 
							bg = "gray")
						}
					}
					else {
					text(xPosi[i], tableX$posi[1], as.character(tableX$label)[1], 
						cex = cex, col = "black")
					}
				}
				else if (variableType[i] == "Mark") {
					if (is.factor(ura[[i]])) {
					tickLabel = as.character(attr(ura[[i]], "levels"))
					}
					else {
						tickLabel = unique(ura[[i]])
					}
					tableX = dataFrame[[i]]
					
					if (is.ordered(ura[[i]])) {
						
						
						
						
						orderedLevel = levels(ura[[i]])
						orderedPosi = tableX[match(orderedLevel, as.character(tableX$label)), ]$posi
						orderedLength = length(orderedPosi)
						if(sum(!is.na(orderedPosi))){
							if (orderedPosi[1] > orderedPosi[orderedLength]) {
								col = "navy"
							}
							else {
								col = 1
							}
						}
						
						
						
						if(sum(diff(tableX$posi[tableX$label!="NA"])>=0)<length(tableX$posi[tableX$label!="NA"])-1){
							if(sum(diff(tableX$posi[tableX$label!="NA"])<=0)<length(tableX$posi[tableX$label!="NA"])-1){
								col="red"
							}
						}
						
						
						
						
						if(sum(!is.na(orderedPosi))){
							for (j in 1:(orderedLength - 1)) {
								if (orderedPosi[j] > orderedPosi[j + 1] & 
								abs(orderedPosi[j] - orderedPosi[j + 1]) > 0.041) {
								arrows(xPosi[i], orderedPosi[j] - 0.02, xPosi[i], orderedPosi[j + 1] + 0.02, col = col, length = 0.1, lwd = lwd)
								}
								else if (orderedPosi[j] < orderedPosi[j + 1] & abs(orderedPosi[j] - orderedPosi[j + 1]) > 0.041) {
									arrows(xPosi[i], orderedPosi[j] + 0.02, xPosi[i], orderedPosi[j + 1] - 0.02, col = col, length = 0.1, lwd = lwd)
								}
							}
						}
					}
					else {
					col = 1
					}
					all.text = c(all.text, as.character(tableX$label))
					all.text.posi = c(all.text.posi, tableX$posi)
					all.text.xPosi = c(all.text.xPosi, rep(xPosi[i], 
					length(tableX$posi)))
					all.text.col = c(all.text.col, rep(ifelse(warp.sel[i], 
					active[1], "black"), length(tableX$posi)))
					all.text.cposi = c(all.text.cposi, rep(0, length(tableX$posi)))
				} else if (variableType[i] == "Cardinal" | variableType[i] == "Count" | variableType[i] == "Ordinal") {
					tableX = dataFrame[[i]]
					yPosi = tableX$posi
					col = 1
					temp = ticks(tableX)
					tickLabel = temp$tickLabel
					tickPosi = temp$tickPosi
					revPosi = temp$revPosi
					cLine = range(yPosi)
					if (length(unique(xx[[i]][!is.na(ura[[i]])])) > 1) {
						Range = ura.attr[[i]]#attr(ura[[i]], "Range")
						if (!is.null(Range)) {
							minLabel = Range$Min
							maxLabel = Range$Max
							Finv1=funcs.inv[warp][variableOrder][[i]]
							Fdir1=funcs[warp][variableOrder][[i]]
							temp = Fdir1(as.numeric(ura[[i]]))
							Coef = lm(xx[[i]] ~ temp)
							if (revPosi) {
								tickMax = ceiling(Finv1((1 - Coef$coef[1])/Coef$coef[2]))
								tickMin = floor(Finv1((0.02 - Coef$coef[1])/Coef$coef[2]))
							}
							else {
								tickMax = floor(Finv1((0.98 - Coef$coef[1])/Coef$coef[2]))
								tickMin = ceiling(Finv1((0 - Coef$coef[1])/Coef$coef[2]))
							}
							Range$Min[predict(Coef, list(temp = Fdir1(Range$Min))) < 0] = tickMin
							Range$Max[predict(Coef, list(temp = Fdir1(Range$Max))) > 1] = tickMax
							Range$Max[predict(Coef, list(temp = Fdir1(Range$Max))) < 0] = tickMin
							Range$Min[predict(Coef, list(temp = Fdir1(Range$Min))) > 1] = tickMax
							Range = Range[(Range$Max - Range$Min) != 0, ]
							if (dim(Range)[1] > 0) {
								temp = NULL
								for (j in dim(Range)[1]) {
									#print(Range)
									#browser()
									temp = c(temp, Range[j, ]$Min:Range[j, ]$Max)
								}
								temp = predict(Coef, list(temp = Fdir1(temp)))
								if (revPosi) {
									col = "navy"
									all.text = c(all.text, c(as.character(min(minLabel)), as.character(max(maxLabel))))
									all.text.posi = c(all.text.posi, c(max(temp) - 0.005, min(temp) - 0.01))
									all.text.xPosi = c(all.text.xPosi, rep(xPosi[i], 2))
									all.text.col = c(all.text.col, rep(ifelse(warp.sel[i], active[1], col), 2))
									all.text.cposi = c(all.text.cposi, c(3, 1))
								} else {
									all.text = c(all.text, c(as.character(min(minLabel)), as.character(max(maxLabel))))
									all.text.posi = c(all.text.posi, c(min(temp) + 0.005, max(temp) + 0.01))
									all.text.xPosi = c(all.text.xPosi, rep(xPosi[i], 2))
									all.text.col = c(all.text.col, rep(ifelse(warp.sel[i], active[1], col), 2))
									all.text.cposi = c(all.text.cposi, c(1, 3))
								}
								if (revPosi) {
									col = "navy"
									arrows(xPosi[i], min(temp) - 0.02+0.001, xPosi[i], min(temp) - 0.02, col = col, length = 0.1)
								} else {
									arrows(xPosi[i], max(temp) + 0.02- 0.001, xPosi[i], max(temp) + 0.02 , col = col, length = 0.1)
								}
								segments(xPosi[i] - 0.01, temp, xPosi[i] + 0.01, temp, col = col)
							} else {
								cat("The range of ")
								cat(longName[i])
								cat(" is invalid!\n")
							}
						} else {
							if (revPosi) {
								col = "navy"
								arrows(xPosi[i], min(xx[[i]]) - 0.02+ 0.001, xPosi[i], min(xx[[i]]) - 0.02 , col = col, length = 0.1)
							} else {
								arrows(xPosi[i], max(xx[[i]]) + 0.02-0.001, xPosi[i], max(xx[[i]]) + 0.02, col = col, length = 0.1)
							}
							segments(xPosi[i] - 0.005, unique(xx[[i]]), xPosi[i] + 0.005, unique(xx[[i]]), col = col)
						}
						segments(rep(xPosi[i], length(tickLabel)), tickPosi, rep(xPosi[i] - 0.07, length(tickLabel)), tickPosi, col = ifelse(warp.sel[i], active[1], col), lwd = lwd)
						all.text = c(all.text, tickLabel)
						all.text.posi = c(all.text.posi, tickPosi)
						all.text.xPosi = c(all.text.xPosi, rep(xPosi[i], 2))
						all.text.col = c(all.text.col, rep(ifelse(warp.sel[i], active[1], col), 2))
						all.text.cposi = c(all.text.cposi, c(2, 2))
					}
					if (sum(tableX$label == "NA")) {
						all.text = c(all.text, "NA")
						all.text.posi = c(all.text.posi, -0.1)
						all.text.xPosi = c(all.text.xPosi, xPosi[i])
						all.text.col = c(all.text.col, ifelse(warp.sel[i], active[1], "black"))
						all.text.cposi = c(all.text.cposi, 0)
					}
				} else if (variableType[i] == "Measurement") {
					tableX = dataFrame[[i]]
					yPosi = tableX$posi
					col = 1
					temp = ticks(tableX)
					tickLabel = temp$tickLabel
					tickPosi = temp$tickPosi
					revPosi = temp$revPosi
					cLine = range(yPosi)
					if (length(unique(xx[[i]][!is.na(ura[[i]])])) > 1) {
						Range = ura.attr[[i]]# attr(ura[[i]], "Range")
						
						if (!is.null(Range)) {
							minLabel = Range$Min
							maxLabel = Range$Max
							Finv1=funcs.inv[warp][variableOrder][[i]]
							Fdir1=funcs[warp][variableOrder][[i]]
							#print(Fdir)
							#print(Fdir)
							temp = Fdir1(as.numeric(ura[[i]]))
							Coef = lm(xx[[i]] ~ temp)
							Range$Min = predict(Coef, list(temp = Fdir1(Range$Min)))
							Range$Max = predict(Coef, list(temp = Fdir1(Range$Max)))
							
							Range$Min[Range$Min > 1] = 1
							Range$Min[Range$Min < 0] = 0
							Range$Max[Range$Max > 1] = 1
							Range$Max[Range$Max < 0] = 0
							Range = Range[(Range$Max - Range$Min) != 0, ]
							if (dim(Range)[1] > 0) {
								
								segments(xPosi[i], 1, xPosi[i], 0, col = "#efefef", lwd = lwd)
								if (revPosi) {
									col="navy"
									all.text = c(all.text, c(as.character(min(minLabel)), as.character(max(maxLabel))))
									all.text.posi = c(all.text.posi, c(max(Range$Min - 0.005), min(Range$Max + 0.005)))
									all.text.xPosi = c(all.text.xPosi, rep(xPosi[i], 2))
									all.text.col = c(all.text.col, rep(ifelse(warp.sel[i], active[1], col), 2))
									all.text.cposi = c(all.text.cposi, c(3, 1))
								} else {
									col="black"
									#arrows(xPosi[i], 1-0.001, xPosi[i], 1, col = col, length = 0.1)
									all.text = c(all.text, c(as.character(min(minLabel)), as.character(max(maxLabel))))
									all.text.posi = c(all.text.posi, c(min(Range$Min + 0.005), max(Range$Max - 0.005)))
									all.text.xPosi = c(all.text.xPosi, rep(xPosi[i], 2))
									all.text.col = c(all.text.col, rep(ifelse(warp.sel[i], active[1], col), 2))
									all.text.cposi = c(all.text.cposi, c(1, 3))
								}
								arrows(xPosi[i], Range$Min, xPosi[i], Range$Max, col = col, length = 0.1)
								#segments(xPosi[i], Range$Min, xPosi[i], Range$Max, col = ifelse(warp.sel[i], active[1], col))
								
							}else {
								cat("The range of ")
								cat(longName[i])
								cat(" is invalid!\n")
								segments(xPosi[i], 1, xPosi[i], 0, col = "red", lwd = lwd)
							}
						}else{
							if (revPosi) {
								col = "navy"
								arrows(xPosi[i], 0+0.001, xPosi[i], 0, col = col, length = 0.1)
							} else {
								arrows(xPosi[i], 1-0.001, xPosi[i], 1, col = col, length = 0.1)
							}
							segments(xPosi[i], 1, xPosi[i], 0, col = "#efefef", lwd = lwd)
						}
						segments(rep(xPosi[i], length(tickLabel)), 
						tickPosi, rep(xPosi[i] - 0.05*cex, length(tickLabel)), 
						tickPosi, col = ifelse(warp.sel[i], active[1], col), lwd = lwd)
						all.text = c(all.text, tickLabel)
						all.text.posi = c(all.text.posi, tickPosi)
						all.text.xPosi = c(all.text.xPosi, rep(xPosi[i], 2))
						all.text.col = c(all.text.col, rep(ifelse(warp.sel[i], active[1], col), 2))
						all.text.cposi = c(all.text.cposi, c(2, 2))
					} else {
						segments(xPosi[i], 1, xPosi[i], 0, col = ifelse(warp.sel[i], active[1], "#efefef"), lwd = lwd)
					}
					if (sum(tableX$label == "NA")) {
						all.text = c(all.text, "NA")
						all.text.posi = c(all.text.posi, -0.1)
						all.text.xPosi = c(all.text.xPosi, xPosi[i])
						all.text.col = c(all.text.col, ifelse(warp.sel[i], active[1], "black"))
						all.text.cposi = c(all.text.cposi, 0)
					}
				}
				text(xPosi[i] + 0.05, -0.3 + na.posi, longName[i], col = ifelse(warp.sel[i], active[1], "navy"), pos = 2, cex = cex, srt = 45)
				if (!is.na(unit[i])) {
					text(xPosi[i] + 0.25, -0.3 + na.posi, paste("(", unit[i], ")", sep = ""), col = "#669999", pos = 2, cex = cex, srt = 45)
				}
			}
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			if (sum(weft.sel)) {
				if (line) {
					if (ID) {
					matpoints(c(0, xPosi[1]), t(cbind(y0[weft.sel], 
						xx[weft.sel, 1])), col = active[2], type = "l", 
						lty = lty, lwd = weft.width * lwd)
					}
					if (line > 1) {
					segment.xPosi1 = NULL
					segment.yPosi1 = NULL
					segment.xPosi2 = NULL
					segment.yPosi2 = NULL
					segment.lwd = NULL
					for (i in 1:(dim(xx)[2] - 1)) {
						xt = table(xx[weft.sel, i], xx[weft.sel, 
						i + 1])
						if (sum(c(xt))) {
						xxt = as.logical(is.na(xx[weft.sel, i]) + 
							is.na(xx[weft.sel, i + 1]))
						ddd = dim(xt)
						xtn = dimnames(xt)
						xtn[[1]] = as.numeric(rep(xtn[[1]], ddd[2]))
						xtn[[2]] = as.numeric(rep(xtn[[2]], rep(ddd[1], 
							ddd[2])))
						xtn[[3]] = c(xt)
						xtn = data.frame(xtn)
						xtn = xtn[xtn[[3]] > 0, ]
						ddd = dim(xtn)
						segment.xPosi1 = c(segment.xPosi1, rep(xPosi[i], 
							ddd[1]))
						segment.yPosi1 = c(segment.yPosi1, xtn[[1]])
						segment.xPosi2 = c(segment.xPosi2, rep(xPosi[i + 
							1], ddd[1]))
						segment.yPosi2 = c(segment.yPosi2, xtn[[2]])
						segment.lwd = c(segment.lwd, xtn[[3]])
						}
					}
					segments(segment.xPosi1, segment.yPosi1, 
						segment.xPosi2, segment.yPosi2, lwd = segment.lwd * 
						lwd * weft.width, lty = lty, col = active[2])
					}
					else {
					matpoints(xPosi, t(xx[weft.sel, ]), col = active[2], 
						type = "l", lty = lty, lwd = lwd * weft.width)
					}
				}
				if (point) {
					xx.selected = lapply(data.frame(xx[weft.sel, 
					]), function(yy) {
					yy[is.na(yy)] = -0.1
					table(yy)
					})
					sel.posi = unlist(lapply(xx.selected, function(yy) {
					as.numeric(names(yy))
					}))
					sel.xPosi = rep(xPosi, unlist(lapply(xx.selected, 
					function(yy) {
						length(yy)
					})))
					sel.multi = unlist(xx.selected)
					points(sel.xPosi, sel.posi, cex = sqrt(sel.multi/mag.max) * 
					7 * mag, lwd = lwd, col = active[3])
				}
			}else{
				if (point) {
					points(all.xPosi, all.posi, cex = sqrt(all.multi/mag.max) * 7 * mag, lwd = lwd, col = inactive[3])
				}
			}
			if (sum(all.text.cposi > 0)) {
				text(all.text.xPosi[all.text.cposi > 0], all.text.posi[all.text.cposi > 
					0], all.text[all.text.cposi > 0], cex = cex, 
					pos = all.text.cposi[all.text.cposi > 0], col = all.text.col[all.text.cposi > 
					0])
			}
			if (sum(all.text.cposi == 0)) {
				text(all.text.xPosi[all.text.cposi == 0], all.text.posi[all.text.cposi == 
					0], all.text[all.text.cposi == 0], cex = cex, 
					col = all.text.col[all.text.cposi == 0])
			}
			if (ID) {
				if (IDwarp) {
					text(rep(0, length(y0)), y0, IDlabel, cex = cex, 
					col = active[4])
					text(0 + 0.04, -0.3 + na.posi, IDlongName, 
					col = "green", pos = 2, cex = cex, srt = 45)
				}
				else {
					if (sum(!weft.sel)) {
					text(rep(0, length(y0[!weft.sel])), y0[!weft.sel], 
						IDlabel[!weft.sel], cex = cex, col = inactive[4])
					}
					if (sum(weft.sel)) {
					text(rep(0, length(y0[weft.sel])), y0[weft.sel], 
						IDlabel[weft.sel], cex = cex, col = active[4])
					}
					text(0 + 0.04, -0.3 + na.posi, IDlongName, col = "navy", pos = 2, cex = cex, srt = 45)
				}
			}
			makeButton(xlim, ylim, bcol, bcol2, bcol3, btext2, visible, visible2, visible3, piece, scaling, visible.clus)
			coor.temp = NULL
			while (1) {#######################{^##################
				
				coor = locator(1)
				#visible.clus=F
				if (!is.null(coor)) {
					if ((coor$y > ylim[2] - 3 * temp1 & coor$y < ylim[2] + temp1) || (coor$y > ylim[1] - temp1 & coor$y < ylim[1])) {
						#################### i ##########################
						if (coor$x > xlim[1] & coor$x < xlim[1] + temp2[1] & coor$y > ylim[2] & coor$y < ylim[2] + temp1) {############### zoomin
							exit.status = 1
							zoom.num = 0
							bcol = bcol.default
							bcol3=bcol3.default
							bcol[1] = "green"
						} else if (coor$x > xlim[1] + temp2[1] & coor$x < xlim[1] + temp2[2] & coor$y > ylim[2] & coor$y < ylim[2] + temp1) {############### zoomout
							exit.status = 99
							if (sum(abs(c(ylim, xlim) - c(ylim.default, xlim.default))) > 0) {
								xlim = xlim.default
								ylim = ylim.default
								ylim[2] = ylim[2]+clus
								xlim[1] = xlim[1]+!ID
								cex = cex.default
								bcol = bcol.default
								bcol3= bcol3.default
								#opr=0
								#point = point.default
								#line = line.default
								#ID = ID.default
								break
							}
							else {
								bcol = bcol.default
								bcol3=bcol3.default
							}
						} else if (coor$x > xlim[1] + temp2[2] & coor$x < xlim[1] + temp2[3] & coor$y > ylim[2] & coor$y < ylim[2] + temp1) { # undo
							if(sum(weft!=weft.old)+sum(warp!=warp.old)+(piece!=piece.old)){
								exit.status=33
								weft.new=weft
								warp.new=warp
								weft=weft.old
								warp=warp.old
								piece=piece.old
								break
							}
						}else if (coor$x > xlim[1] + temp2[3] & coor$x < xlim[1] + temp2[4] & coor$y > ylim[2] & coor$y < ylim[2] + temp1) { #redo
							if(sum(weft!=weft.new)+sum(warp!=warp.new)){
								exit.status=34
								weft=weft.new
								warp=warp.new
								break
							}
						}else if (coor$x > xlim[1] + temp3[4] & coor$x < xlim[1] + temp3[5] & coor$y > ylim[2] & coor$y < ylim[2] + temp1) { # init
							exit.status = 13
							xlim = xlim.default
							ylim = ylim.default
							piece = piece.default
							bcol3=bcol3.default
							ID = ID.default
							clus=0
							visible=F
							visible2=F
							visible3=F
							visible.clus=F
							opr=0
							cex = cex.default
							point=point.default
							funcs = funcs.default
							funcs.inv = funcs
							line=line.default
							ord=ord.default
							weft.sel = rep(F, dim(xx)[1])
							warp.sel = rep(F, dim(xx)[2])
							Point = matrix(rep(F, prod(dim(xx))), dim(xx)[1])
							active = active.default
							break
						} else if (coor$x > xlim[1] + temp3[5] & coor$x < xlim[1] + temp3[5]+temp3[1]/2 & coor$y > ylim[2] & coor$y < ylim[2] + temp1) { # cex+
							cex=min(cex*1.2,1)
							break
						} else if (coor$x > xlim[1] + temp3[5]+temp3[1]/2 & coor$x < xlim[1] + temp3[6] & coor$y > ylim[2] & coor$y < ylim[2] + temp1) { # cex-
							cex=max(cex*0.8,0.1)
							break
						} else if (coor$x > xlim[2] - temp2[1] & coor$x < xlim[2] & coor$y > ylim[2] & coor$y < ylim[2] + temp1) { #quit
							exit.status = 0
							bcol = bcol.default
							bcol3=bcol3.default
							opr=0
							break
						}###############################	i	################################
						else if (coor$x > xlim[1] & coor$x < xlim[1] + temp2[1] & coor$y < ylim[2] & coor$y > ylim[2] - temp1) {############ warp 2-1
							visible = T
							
							exit.status = 21
							point.num = 0
							bcol = bcol.default
							bcol[5] = "green"
							if (sum(weft.sel) || sum(Point)) {
								opr=0
								weft.sel = rep(F, dim(xx)[1])
								warp.sel = rep(F, dim(xx)[2])
								bcol3=bcol3.default
								#bcol3[1]="green"
								active = active.default
								inactive = inactive.default
								visible2=F
								visible3=F
								break
							}else{
								if(sum(warp.sel)+IDwarp==0){
									opr=0
									#bcol3=bcol3.default
									#bcol3[1]="green"
								}else{
									bcol3=bcol3.default
									bcol3[2]="green"
									opr=1
								}
							}
						}else if (coor$x > xlim[1] + temp2[1] & coor$x < xlim[1] + temp2[2] & coor$y < ylim[2] & coor$y > ylim[2] - temp1) {############ weft 2-2
							visible=T
							exit.status = 22
							point.num = 0
							bcol = bcol.default
							bcol[6] = "green"
							if (sum(warp.sel) + IDwarp || sum(Point)) {
								opr=0
								bcol3=bcol3.default
								weft.sel = rep(F, dim(xx)[1])
								warp.sel = rep(F, dim(xx)[2])
								active = active.default
								inactive = inactive.default
								#bcol3[2]="green"
								visible2=F
								visible3=F
								break
							}else{
								if(sum(weft.sel)==0){
									opr=0
									bcol3=bcol3.default
									#bcol3[1]="green"
								}else{
									opr=1
									bcol3=bcol3.default
									bcol3[2]="green"
								}
							}
						}else if (coor$x > xlim[1] + temp2[2] & coor$x < xlim[1] + temp2[3] & coor$y < ylim[2] & coor$y > ylim[2] - temp1) { ############ point 2-3
							visible=T
							
							exit.status = 23
							point.num = 0
							bcol = bcol.default
							bcol[7] = "green"
							if (sum(Point)==0 & (sum(weft.sel)+sum(warp.sel)+IDwarp)) {
								#print("koko")
								opr=0
								bcol3=bcol3.default
								weft.sel = rep(F, dim(xx)[1])
								warp.sel = rep(F, dim(xx)[2])
								IDwarp=F
								active = active.default
								inactive = inactive.default
								#bcol3[2]="green"
								visible2=F
								visible3=F
								break
							}else{
								bcol3=bcol3.default
								#bcol3[1]="green"
								opr=0
							}
						} else if (coor$x > xlim[1] + temp2[3] & coor$x < xlim[1] + temp2[4] & coor$y < ylim[2] & coor$y > ylim[2] - temp1) { ############ point 2-4
							visible=F
							visible2=F
							visible3=F
							exit.status = 24
							point.num = 0
							bcol = bcol.default
							weft.sel = rep(F, dim(xx)[1])
							warp.sel = rep(F, dim(xx)[2])
							IDwarp=F
							IDweft=F
							Point = matrix(rep(F, prod(dim(xx))),dim(xx)[1])
							bcol3=bcol3.default
							active = active.default
							inactive = inactive.default
							opr=0
							break
						} ################################ Oi ################################
						else if (coor$x > xlim[1] & coor$x < xlim[1] + temp3[1] & coor$y < ylim[2] - 1* temp1 & coor$y > ylim[2] - 2 * temp1) {#################### 3-1
							if(visible){
								bcol3=c("green",rep("#999999",4))
								opr=0
								point.num=0
							}
						}else if (coor$x > xlim[1] +temp3[1] & coor$x < xlim[1] + temp3[2] & coor$y < ylim[2] - 1* temp1 & coor$y > ylim[2] - 2 * temp1) {#################### 3-2
							if(visible){
								bcol3=c(rep("#999999",1),"green",rep("#999999",3))
								point.num=0
								opr=1
							}
						}else if (coor$x > xlim[1] +temp3[2] & coor$x < xlim[1] + temp3[3] & coor$y < ylim[2] - 1* temp1 & coor$y > ylim[2] - 2 * temp1) {#################### 3-3
							if(visible){
								bcol3=c(rep("#999999",2),"green",rep("#999999",2))
								point.num=0
								opr=2
							}
						}else if (coor$x > xlim[1] +temp3[3] & coor$x < xlim[1] + temp3[4] & coor$y < ylim[2] - 1* temp1 & coor$y > ylim[2] - 2 * temp1) {#################### 3-4
							if(visible){
								bcol3=c(rep("#999999",3),"green",rep("#999999",1))
								point.num=0
								opr=3
							}
						}else if (coor$x > xlim[1] +temp3[4] & coor$x < xlim[1] + temp3[5] & coor$y < ylim[2] - 1* temp1 & coor$y > ylim[2] - 2 * temp1) {#################### 3-5
							if(visible){
								bcol3=c(rep("#999999",4),"green")
								point.num=0
								opr=4
							}
						}################################### li #########################
						else if (coor$x > xlim[1] & coor$x < xlim[1] + temp2[1] & coor$y < ylim[2] - 2* temp1 & coor$y > ylim[2] - 3 * temp1) {#################### 4-1
							if(visible & visible2){
								weft.old=weft
								warp.old=warp
								if (sum(warp.sel) + IDwarp) {
									if ((sum(warp.sel) + IDwarp) < 2) {
										##print(last.warning)
										cat("We need more warps!\n")
									}else {
										exit.status = 31
										warp[warp][variableOrder] = warp.sel
										point.num = 0
										bcol = bcol.default
										active = active.default
										inactive = inactive.default
										cex = cex.default
										break
									}
								}else if (sum(weft.sel)) {
									if (sum(weft.sel) < 2) {
										cat("We need more wefts!\n")
									}else {
										exit.status = 31
										weft[weft] = weft.sel
										point.num = 0
										bcol = bcol.default
										active = active.default
										inactive = inactive.default
										cex = cex.default
										break
									}
								}
							}
						}else if (coor$x > xlim[1] + temp2[1] & coor$x < xlim[1] + temp2[2] & coor$y < ylim[2] - 2 * temp1 & coor$y > ylim[2] - 3 * temp1) {#########################3 4-2
							if(visible & visible2){
								weft.old=weft
								warp.old=warp
								if (sum(warp.sel) + IDwarp) { 
									if ((sum(!warp.sel) + (!IDwarp)) < 2) {
										cat("We need more warps!\n")
									}else {
										exit.status = 32
										#print(last.warning)
										warp[warp][variableOrder] = !warp.sel
										#print(last.warning)
										if (IDwarp) {
											ID = F
										}
										cex=cex.default
										point.num = 0
										bcol = bcol.default
										active = active.default
										inactive = inactive.default
										break
									}
								}
								else if (sum(weft.sel)) {
									if (sum(!weft.sel) < 2) {
										cat("We need more wefts!\n")
									}else {
										cex=cex.default
										exit.status = 32
										weft[weft] = !weft.sel
										point.num = 0
										bcol = bcol.default
										active = active.default
										inactive = inactive.default
										break
									}
								}
							}
						} else if (coor$x > xlim[1] + temp2[2] & coor$x < xlim[1] + temp2[3] & coor$y < ylim[2] - 2 * temp1 & coor$y > ylim[2] - 3 * temp1) {#########################3 4-3
							if(visible & visible2 & visible3){
								if(bcol[10]=="green"){
									bcol[10]="#999999"
									exit.status=21
								}else{
									bcol[10]="green"
									exit.status=43
								}
							}
						} else if (coor$x > xlim[1] + temp2[3] & coor$x < xlim[1] + temp2[4] & coor$y < ylim[2] - 2 * temp1 & coor$y > ylim[2] - 3 * temp1) {#########################3 4-4
							if(visible & visible2 & visible3){
								rect(xlim[1] + temp2[3], ylim[2] - 2 * temp1, xlim[1] + temp2[4], ylim[2] - 3 * temp1, border=0, col="green")
								text(xlim[1] + temp2[3]+temp2[1]/2, ylim[2] - 2.5 * temp1, "Transform",cex=cex.menu, col="white")
								cat("Enter the function definition for nonlinear transfromation: \n")
								Fdir = eval(parse(text=paste("function(x){", readline(), "}", sep="")))
								cat("Enter the inverse function definition for nonlinear transfromation: \n")
								Finv = eval(parse(text=paste("function(x){", readline(), "}", sep="")))
								
								funcs[warp][variableOrder][warp.sel] = lapply(funcs[warp][variableOrder][warp.sel], 
								  function(func1, func2){as.function(alist(x=,func2(func1(x))))},Fdir)
								  
								
								funcs.inv[warp][variableOrder][warp.sel] = lapply(funcs.inv[warp][variableOrder][warp.sel], 
								  function(func1, func2){as.function(alist(x=,func2(func1(x))))},Finv)
								cex = cex.default
								exit.status = 44
								break
							}
						################# ŉi ################### 5-1
						} else if (coor$x > xlim[1] & coor$x < xlim[1] + temp3[1] & coor$y < ylim[1] & coor$y > ylim[1] - temp1) {# ID warp
							#exit.status = 41
							if (ID) {
								ID = F
								IDwarp = F
								bcol2[1] = "black"
								xlim = xlim.default
								ylim = ylim.default
								xlim[1] = xlim[1] + 1
								ylim[2] = ylim[2]+clus
							}else {
								ID = T
								bcol2[1] = "#669999"
								xlim = xlim.default
								ylim = ylim.default
								ylim[2] = ylim[2]+clus
								#xlim[1] = xlim[1] - ifelse(ID.default, 0, 1)
							}
							#bcol = bcol.default
							break
						} else if (coor$x > xlim[1] + temp3[1] & coor$x < xlim[1] + temp3[2] & coor$y < ylim[1] & coor$y > ylim[1] - temp1) { # order of axes
							#exit.status = 42
							bcol2[2:4] = c("black", "#669999", "black")
							ord = 0
							clus=0
							ylim=ylim.default
							#bcol = bcol.default
							break
						} else if (coor$x > xlim[1] + temp3[2] & coor$x < xlim[1] + temp3[3] & coor$y < ylim[1] & coor$y > ylim[1] - temp1) {
							#exit.status = 43
							bcol2[2:4] = c("#669999", "black", "black")
							ord = 1
							clus=0
							ylim=ylim.default
							#bcol = bcol.default
							break
						} else if (coor$x > xlim[1] + temp3[3] & coor$x < xlim[1] + temp3[4] & coor$y < ylim[1] & coor$y > ylim[1] - temp1) {
							#exit.status = 44
							bcol2[2:4] = c("black", "black", "#669999")
							visible.clus=T
							#ord = 2
							#bcol = bcol.default
							#break
						} else if (coor$x > xlim[1] + temp3[4] & coor$x < xlim[1] + temp3[5] & coor$y < ylim[1] & coor$y > ylim[1] - temp1) { # thick weft
							#exit.status = 45
							if (line) {
								if (line == 1) {
									line = 2
									bcol2[5] = "#669999"
								} else {
									line = 0
									bcol2[5] = "black"
								}
							}else {
								line = 1
								bcol2[5] = "#669999"
							}
							#bcol = bcol.default
							break
						} else if (coor$x > xlim[1] + temp3[5] & coor$x < xlim[1] + temp3[6] & coor$y < ylim[1] & coor$y > ylim[1] - temp1) { # point design
							#exit.status = 46
							if (point) {
								point = F
								bcol2[6] = "black"
							} else {
								point = T
								bcol2[6] = "#669999"
							}
							#bcol = bcol.default
							break
						} else if (coor$x > xlim[1] + temp3[6] & coor$x < xlim[1] + temp3[1]*7 & coor$y < ylim[1] & coor$y > ylim[1] - temp1) { # rescaling
							if(scaling){
								scaling=F
							}else{
								scaling=T
							}
							exit.status=58
							break
						} else if (coor$x > xlim[1] + temp3[1]*7 & coor$x < xlim[2] & coor$y < ylim[1] & coor$y > ylim[1] - temp1) { # Piece
							piece.old=piece
							if(piece<dim(xx)[2]){
								piece = piece+1
							}else{
								piece=1
							}
							exit.status=57
							break
						}
						#makeButton(xlim, ylim, bcol, bcol2, bcol3, btext2, visible, visible2, visible3, piece, scaling, visible.clus)
						##### CLUSTER #####
					} else if ((visible.clus && (coor$y > ylim[1] & coor$y < ylim[1]+temp1*8) && (coor$x > xlim[1]+temp2[1]*3 & coor$x < xlim[1]+temp2[1]*4))) {
						if (coor$y > ylim[1] & coor$y < ylim[1]+temp1) {
							method="ward"
						} else if (coor$y > ylim[1]+temp1 & coor$y < ylim[1]+temp1*2) {
							method="single"
						} else if (coor$y > ylim[1]+temp1*2 & coor$y < ylim[1]+temp1*3) {
							method="complete"
						} else if (coor$y > ylim[1]+temp1*3 & coor$y < ylim[1]+temp1*4) {
							method="average"
						} else if (coor$y > ylim[1]+temp1*4 & coor$y < ylim[1]+temp1*5) {
							method="mcquitty"
						} else if (coor$y > ylim[1]+temp1*5 & coor$y < ylim[1]+temp1*6) {
							method="median"
						} else if (coor$y > ylim[1]+temp1*6 & coor$y < ylim[1]+temp1*7) {
							method="centroid"
						} else if (coor$y > ylim[1]+temp1*7 & coor$y < ylim[1]+temp1*8) {
							method="kumasaka"
						}
						clus=0.4
						ylim = ylim.default
						xlim = xlim.default
						ylim[2]=ylim[2]+clus
						xlim[1] = xlim[1] + !ID
						ord=2
						visible.clus = F
						break
					} else {	################# {^ȊO ################### 
						if (exit.status == 1) {
							if (zoom.num > 0) {
								ylim = sort(c(coor$y, coor.temp$y))
								xlim = sort(c(coor$x, coor.temp$x))
								cex = min(1, diff(ylim.default)/diff(ylim) * cex.default)
								zoom.num = 0
								par(mar = c(1, 1, 1, 1))
								bcol = bcol.default
								exit.status = 11
								break
							}
							else {
							coor.temp = coor
							zoom.num = 1
							}
						} else if (exit.status == 11) {
							centre.coor = c(coor$x, coor$y) - c(mean(xlim), 
							mean(ylim))
							if (centre.coor[1] > 0) {
							xlim = xlim + min(xlim.default[2] - xlim[2], 
								centre.coor[1])
							}
							else {
							xlim = xlim + max(xlim.default[1] - xlim[1], 
								centre.coor[1])
							}
							if (centre.coor[2] > 0) {
							ylim = ylim + min(ylim.default[2] - ylim[2], 
								centre.coor[2])
							}
							else {
							ylim = ylim + max(ylim.default[1] - ylim[1], 
								centre.coor[2])
							}
							break
						} else if (exit.status > 20 & exit.status < 30) {
							if (point.num > 0) {
								visible2=T
								ylim.point = sort(c(coor$y, coor.temp$y))
								xlim.point = sort(c(coor$x, coor.temp$x))
								warp.sel.old=warp.sel
								weft.sel.old=weft.sel
								IDweft.old=IDweft
								IDwarp.old=IDwarp
								warp.sel = xlim.point[1] <= xPosi & xlim.point[2] >= xPosi
								Point = matrix(rep(F, prod(dim(xx))), dim(xx)[1])
								IDweft = Point[, 1]
								IDwarp = xlim.point[1] <= 0 & xlim.point[2] >= 0
								if (exit.status == 21) { ################## WARP
									visible3=T
									weft.sel = rep(F, dim(xx)[1])
									if(opr==1){
										warp.sel = warp.sel | warp.sel.old
										IDwarp = IDwarp | IDwarp.old
									}else if(opr==2){
										warp.sel = warp.sel & warp.sel.old
										IDwarp = IDwarp & IDwarp.old
									}else if(opr==3){
										warp.sel = (!warp.sel) & warp.sel.old
										IDwarp = !IDwarp & IDwarp.old
									}else if(opr==4){
										warp.sel = xor(warp.sel, warp.sel.old)
										IDwarp = xor(IDwarp, IDwarp.old)
									}else{
										opr=1
										bcol3=bcol3.default
										bcol3[2]="green"
									}
									
									Point = F
									active = c("green", "gray", "black", "green")
									inactive = c("#999999", "gray", "black", "black")
									#bcol3=bcol3.default
									#bcol3[2]="green"
								}else if (exit.status == 22) { #################### WEFT
									visible3=F
									xx = cbind(y0, xx)
									weft.sel = rep(F, dd[1])
									for (k in max(c(floor(xlim.point[1] + 
									1), 1)):min(c(ceiling(xlim.point[2]), 
									dd[2]))) {
									weft.sel = cbind(weft.sel, conv(max(c(xlim.point[1] - 
										k + 1, 0)), min(c(xlim.point[2] - 
										k + 1, 1)), ylim.point[1], ylim.point[2], 
										xx[, k:(k + 1)]))
									}
									weft.sel = apply(weft.sel, 1, sum, na.rm = T)
									weft.sel = weft.sel > 0
									weft.sel[is.na(weft.sel)] = F
									
									
									if(opr==1){
										weft.sel = weft.sel | weft.sel.old
									}else if(opr==2){
										weft.sel = weft.sel & weft.sel.old
									}else if(opr==3){
										weft.sel = (!weft.sel) & weft.sel.old
									}else if(opr==4){
										weft.sel = xor(weft.sel, weft.sel.old)
									}else{
										opr=0
										bcol3=bcol3.default
										bcol3[1]="green"
									}
									xx = xx[, -1]
									warp.sel = rep(F, dim(xx)[2])
									Point = F
									IDwarp = F
									active = c("black", "green", "#cccccc", "green")
									inactive = c("black", "#efefef", "#efefef", "gray")
								}else if (exit.status == 23) { ################# POINT
									visible3=F
									if (sum(warp.sel)) {
										if (sum(warp.sel + 0) == 1) {
											temp = xx[, warp.sel]
											temp[is.na(temp)] = -0.1
											Point[, warp.sel] = temp >= ylim.point[1] & 
											temp <= ylim.point[2]
										}
										else {
											Point[, warp.sel] = as.matrix(apply(xx[, 
											warp.sel], 2, function(xxx.brush) {
											xxx.brush[is.na(xxx.brush)] = -0.1
											xxx.brush >= ylim.point[1] & 
												xxx.brush <= ylim.point[2]
											}))
										}
									}
									if (IDwarp) {
									IDweft = y0 >= ylim.point[1] & y0 <= ylim.point[2]
									}
									weft.sel = as.logical(apply(cbind(IDweft, Point), 1, sum))
									warp.sel = rep(F, dim(xx)[2])
									
									if(opr==1){
										weft.sel = weft.sel | weft.sel.old
									}else if(opr==2){
										weft.sel = weft.sel & weft.sel.old
									}else if(opr==3){
										weft.sel = (!weft.sel) & weft.sel.old
									}else if(opr==4){
										weft.sel = xor(weft.sel, weft.sel.old)
									}else{
										opr=0
										bcol3=bcol3.default
										bcol3[1]="green"
									}
								
									Point = T
									IDwarp = F
									active = c("black", "#ababab", "#00F200", "black")
									inactive = c("black", "#efefef", "#efefef", "#cccccc")
								}
								point.num = 0
								break
							}else {
								coor.temp = coor
								point.num = 1
							}
						}else if(exit.status==43){
							if(coor$x<1){
								variableOrder = c(variableOrder[warp.sel], variableOrder[!warp.sel & seq(length(variableOrder))>coor$x])
								warp.sel = c(warp.sel[warp.sel], warp.sel[!warp.sel & seq(length(variableOrder))>coor$x])
							}else if(coor$x>length(variableOrder)){
								variableOrder = c(variableOrder[!warp.sel & seq(length(variableOrder))<coor$x], variableOrder[warp.sel])
								warp.sel = c(warp.sel[!warp.sel & seq(length(variableOrder))<coor$x], warp.sel[warp.sel])
							}else{
								variableOrder = c(variableOrder[!warp.sel & seq(length(variableOrder))<coor$x], variableOrder[warp.sel], variableOrder[!warp.sel & seq(length(variableOrder))>coor$x])
								warp.sel = c(warp.sel[!warp.sel & seq(length(variableOrder))<coor$x], warp.sel[warp.sel], warp.sel[!warp.sel & seq(length(variableOrder))>coor$x])
							}
							#opr=0
							#bcol[10] = "#999999"
							#exit.status=21
							
							ord=4
							#exit.status=99
							break
						}else{
							if(visible + visible2 + visible3 + visible.clus){
								visible = F
								visible2= F
								visible3= F
								visible.clus = F
								exit.status = 99
								break
							}
							exit.status = 99
						}
					}
					makeButton(xlim, ylim, bcol, bcol2, bcol3, btext2, visible, visible2, visible3, piece, scaling, visible.clus)
				}
				else {
					exit.status = 0
					break
				}
			}
			if (exit.status == 31 || exit.status==32 || exit.status==33 || exit.status==34 || exit.status==58 || exit.status==57 || exit.status==44) {
				exit.status = 99
				print(ylim)
				break
			}
			else if (exit.status == 13) {
				warp = rep(T, length(ura.default))
				weft = rep(T, length(ura.default[[1]]))
				exit.status = 99
				ID = ID.default
				break
			}
		}
		makeButton(xlim, ylim, bcol, bcol2, bcol3, btext2, visible, visible2, visible3, piece, scaling, visible.clus)
	}
}
