vclust=function (x, labels = NULL, hang =15, axes = F, frame.plot = FALSE, 
    ann = F, main = "Cluster Dendrogram", sub = NULL, xlab = NULL, 
    ylab = "", variableOrder, clus, method, cex,...) 
{
        
    x$height = (x$height-min(x$height))/diff(range(x$height))*clus*0.85 + 1 + 0.15*cex
    x$order = variableOrder
    
    
    
    merge <- x$merge
    if (!is.matrix(merge) || ncol(merge) != 2) 
        stop("invalid dendrogram")
    if (any(as.integer(merge) != merge)) 
        stop("'merge' component in dendrogram must be integer")
    storage.mode(merge) <- "integer"
    n <- nrow(merge)
    height <- as.double(x$height)
    labels <- if (missing(labels) || is.null(labels)) {
        if (is.null(x$labels)) 
            paste(1:(n + 1))
        else as.character(x$labels)
    }
    else {
        if (is.logical(labels) && !labels) 
            character(n + 1)
        else as.character(labels)
    }
    #plot.new()
    #.Internal(dend.window(n, merge, height, hang, labels, ...))
    .Internal(dend(n, merge, height, order(x$order), hang, labels, 
        ...))
    if (axes) 
        axis(2, at = pretty(range(height)))
    if (frame.plot) 
        box(...)
    if (ann) {
        if (!is.null(cl <- x$call) && is.null(sub)) 
            sub <- paste(deparse(cl[[1]]), " (*, \"", x$method, 
                "\")", sep = "")
        if (is.null(xlab) && !is.null(cl)) 
            xlab <- deparse(cl[[2]])
        title(main = main, sub = sub, xlab = xlab, ylab = ylab, 
            ...)
    }
    rect(-1,-1,length(variableOrder)+1,1 + cex*0.1, col="white",border=0)
    invisible()
}
