\name{attachDandD}
\title{Attach Set of DandD Objects to Search Path}
\usage{
attachDandD(dad)
}
\alias{attachDandD}
\arguments{
  \item{dad}{``dad'' object, created by \code{\link{DandD}}.}
}
\description{
  Any components defined in <Data>  of the DandD instance corresponding to 
 the given ``dad'' object are attached to the \R search path.  
  This means that any data vector organized in <Data> are searched by \R when   evaluating a variable.  Usually, this function is called implicitly by \print
  method for dad object.

\details{
  By attaching a ``dad'' object to the search path, it is possible to refer 
  to each data vector organized in <Data> by their abbreviated names alone.
  Such abbreviated names can be identified to the LongName simply by
  typing the name of the ``dad object''.  Otherwise, explicit specification of
  each vector like \code{eval(obj$women$height)}) is required.

  By default an components in <Data > are attached in position 2 and later
  in the search path, immediately after the user's workspace and before all
  previously loaded packages and previously attached databases. 
}
\value{
  The \code{\link{environments}} are returned invisibly with 
  \code{"name"} attributes .
}
\references{
}
\seealso{
  \code{\link{DandD}}, \code{\link{attach}}, 
  \code{\link{library}}, \code{\link{detach}}, \code{\link{search}},
  \code{\link{objects}}, \code{\link{environment}}.
}
\examples{
acidRain=DandD("AcidRain.dad")
search()
attachDandD(acidRain)
search()
}
\keyword{data}
