\name{connections}
\alias{openConn}
\alias{closeConn}
\title{Functions to Open and Close Connection to a DandD Server}
\description{
  Functions to open and close connection to a DandD Server.
  Usually this function is implicitly called by the function DandD.
}
\usage{
openConn(address = Server$address)
closeConn()
}
\arguments{
  \item{address}{IP Address of DandD Server.  By default it is set 
  the ``address'' component  of the current DandD Server descriptor 
  \code{.Server} stored
  in ``package:dad'' environment.}
}
\details{
  \code{openConn} creates a socket and establish a connection to 
  the specified DandD Server.  
  If the connection is successful,  the ``connected'' component is created in
  the current DandD Server descriptor \code{.Server}.
}
\seealso{
  \code{\link{DandD}}, \code{\link{setDandDServer}}.
}

\examples{
library(dad)
.Server #  ` `.Server$connected'' is null.
openConn()
.Server # If the connection were not successful,   ``.Server$connected'' is null.
}
\keyword{DandD}
\keyword{connection}
\keyword{dad}
\keyword{open}
\keyword{close}
