\name{setDandDServer}
\alias{setDandDServer}
\title{Set IP Address of DandD Server}
\description{
  Function to set the IP Address of a DandD Server.
}
\usage{
setDandDServer(address = "131.113.65.15")
}
\arguments{
  \item{address}{ IP Address or the address name of a DandD Server}
}
\details{
  This function will set a default IP address of DandD Server.
  It is stored in the server descriptor \code{.Server}
  stored in \code{package:dad} environment.  It will be used as
  the default address to the function \code{OpenConn}.
}

\value{
  IP Address of DandD Server ( a character string ) .
}
\seealso{
  \code{\link{DandD}}, \code{\link{openConn}}, \code{\link{closeConn}}.
}

\examples{
library(dad)
.Server
setDandDServer("127.0.0.1")
.Server
}
\keyword{DandD}
\keyword{dad}
\keyword{open}
\keyword{close}
