\name{attachDandD}
\title{Attach Set of DandD Objects to Search Path}
\usage{
attachDandD(dad)
}
\alias{attachDandD}
\arguments{
  \item{dad}{``dad'' object, created with \code{\link{DandD}}.}
}
\description{
  The data structures in dad object are attached to the \R search path.  
  This means that the structures are searched by \R when evaluating a variable, 
  so data vectors in the structure can be accessed by simply giving their names.}

\details{
  By attaching a dad object to the search path it is possible to refer 
  to the variables in the data structure by their names alone, rather than 
  evaluateing variables in data structure(eg in the example below,
  \code{height} rather than \code{eval(obj$women$height)}).

  By default the data structures in dad object are attached in position 2 and later
  in the search path, immediately after the user's workspace and before all previously
  loaded packages and previously attached databases. 
}
\value{
  The \code{\link{environments}} are returned invisibly with 
  \code{"name"} attributes .
}
\references{
}
\seealso{
  \code{\link{DandD}}, \code{\link{attach}}, 
  \code{\link{library}}, \code{\link{detach}}, \code{\link{search}},
  \code{\link{objects}}, \code{\link{environment}}.
}
\examples{
acidRain=DandD("AcidRain.dad")
search()
attachDandD(acidRain)
search()
}
\keyword{data}
