\name{connections}
\alias{openConn}
\alias{closeConn}
\title{Functions to Open and Close Connections to DandD Server}
\description{
  Functions to open and close connections to DandD Server.
}
\usage{
openConn(address = Server$address)
closeConn()
}
\arguments{
  \item{address}{IP Address of DandD Server. By default it is set the ``address'' component 
of Serverv descripter \code{.Server} stored in ``package:dad'' environment.}
}
\details{
  \code{openConn} creates a socket and opens a connection to the DandD Server.  
  If the connection is success, ``connected'' component is created in \code{.Server}.
}
\seealso{
  \code{\link{DandD}}, \code{\link{setDandDServer}}.
}

\examples{
library(dad)
.Server #``.Server$connected'' is null.
openConn()
.Server #If ``.Server$connected'' is still null, connection failed.
}
\keyword{DandD}
\keyword{connection}
\keyword{dad}
\keyword{open}
\keyword{close}
